/* original parser id follows */
/* yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93" */
/* (use YYMAJOR/YYMINOR for ifdefs dependent on parser version) */

#define YYBYACC 1
#define YYMAJOR 2
#define YYMINOR 0
#define YYPATCH 20221106

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)
#define YYENOMEM       (-2)
#define YYEOF          0
#undef YYBTYACC
#define YYBTYACC 0
#define YYDEBUGSTR YYPREFIX "debug"
#define YYPREFIX "yy"

#define YYPURE 0

#line 26 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/queue.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <net/if.h>
#include <netinet/in.h>
#include <netinet/ip_ipsp.h>
#include <arpa/inet.h>

#include <ctype.h>
#include <err.h>
#include <errno.h>
#include <fcntl.h>
#include <ifaddrs.h>
#include <limits.h>
#include <netdb.h>
#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <syslog.h>
#include <unistd.h>
#include <netdb.h>
#include <event.h>

#include <net/pfkeyv2.h>

#include "iked.h"
#include "ikev2.h"
#include "eap.h"

TAILQ_HEAD(files, file)		 files = TAILQ_HEAD_INITIALIZER(files);
static struct file {
	TAILQ_ENTRY(file)	 entry;
	FILE			*stream;
	char			*name;
	size_t			 ungetpos;
	size_t			 ungetsize;
	u_char			*ungetbuf;
	int			 eof_reached;
	int			 lineno;
	int			 errors;
} *file, *topfile;
struct file	*pushfile(const char *, int);
int		 popfile(void);
int		 check_file_secrecy(int, const char *);
int		 yyparse(void);
int		 yylex(void);
int		 yyerror(const char *, ...)
    __attribute__((__format__ (printf, 1, 2)))
    __attribute__((__nonnull__ (1)));
int		 kw_cmp(const void *, const void *);
int		 lookup(char *);
int		 igetc(void);
int		 lgetc(int);
void		 lungetc(int);
int		 findeol(void);

TAILQ_HEAD(symhead, sym)	 symhead = TAILQ_HEAD_INITIALIZER(symhead);
struct sym {
	TAILQ_ENTRY(sym)	 entry;
	int			 used;
	int			 persist;
	char			*nam;
	char			*val;
};
int		 symset(const char *, const char *, int);
char		*symget(const char *);

#define KEYSIZE_LIMIT	1024

static struct iked	*env = NULL;
static int		 debug = 0;
static int		 rules = 0;
static int		 passive = 0;
static int		 decouple = 0;
static int		 mobike = 1;
static int		 enforcesingleikesa = 0;
static int		 stickyaddress = 0;
static int		 fragmentation = 0;
static int		 vendorid = 1;
static int		 dpd_interval = IKED_IKE_SA_ALIVE_TIMEOUT;
static char		*ocsp_url = NULL;
static long		 ocsp_tolerate = 0;
static long		 ocsp_maxage = -1;
static int		 cert_partial_chain = 0;

struct iked_transform ikev2_default_ike_transforms[] = {
	{ IKEV2_XFORMTYPE_ENCR, IKEV2_XFORMENCR_AES_CBC, 256 },
	{ IKEV2_XFORMTYPE_ENCR, IKEV2_XFORMENCR_AES_CBC, 192 },
	{ IKEV2_XFORMTYPE_ENCR, IKEV2_XFORMENCR_AES_CBC, 128 },
	{ IKEV2_XFORMTYPE_ENCR, IKEV2_XFORMENCR_3DES },
	{ IKEV2_XFORMTYPE_PRF,	IKEV2_XFORMPRF_HMAC_SHA2_256 },
	{ IKEV2_XFORMTYPE_PRF,	IKEV2_XFORMPRF_HMAC_SHA2_384 },
	{ IKEV2_XFORMTYPE_PRF,	IKEV2_XFORMPRF_HMAC_SHA2_512 },
	{ IKEV2_XFORMTYPE_PRF,	IKEV2_XFORMPRF_HMAC_SHA1 },
	{ IKEV2_XFORMTYPE_INTEGR, IKEV2_XFORMAUTH_HMAC_SHA2_256_128 },
	{ IKEV2_XFORMTYPE_INTEGR, IKEV2_XFORMAUTH_HMAC_SHA2_384_192 },
	{ IKEV2_XFORMTYPE_INTEGR, IKEV2_XFORMAUTH_HMAC_SHA2_512_256 },
	{ IKEV2_XFORMTYPE_INTEGR, IKEV2_XFORMAUTH_HMAC_SHA1_96 },
	{ IKEV2_XFORMTYPE_DH,	IKEV2_XFORMDH_CURVE25519 },
	{ IKEV2_XFORMTYPE_DH,	IKEV2_XFORMDH_ECP_521 },
	{ IKEV2_XFORMTYPE_DH,	IKEV2_XFORMDH_ECP_384 },
	{ IKEV2_XFORMTYPE_DH,	IKEV2_XFORMDH_ECP_256 },
	{ IKEV2_XFORMTYPE_DH,	IKEV2_XFORMDH_MODP_4096 },
	{ IKEV2_XFORMTYPE_DH,	IKEV2_XFORMDH_MODP_3072 },
	{ IKEV2_XFORMTYPE_DH,	IKEV2_XFORMDH_MODP_2048 },
	{ IKEV2_XFORMTYPE_DH,	IKEV2_XFORMDH_MODP_1536 },
	{ IKEV2_XFORMTYPE_DH,	IKEV2_XFORMDH_MODP_1024 },
	{ 0 }
};
size_t ikev2_default_nike_transforms = ((sizeof(ikev2_default_ike_transforms) /
    sizeof(ikev2_default_ike_transforms[0])) - 1);

struct iked_transform ikev2_default_ike_transforms_noauth[] = {
	{ IKEV2_XFORMTYPE_ENCR,	IKEV2_XFORMENCR_AES_GCM_16, 128 },
	{ IKEV2_XFORMTYPE_ENCR,	IKEV2_XFORMENCR_AES_GCM_16, 256 },
	{ IKEV2_XFORMTYPE_PRF,	IKEV2_XFORMPRF_HMAC_SHA2_256 },
	{ IKEV2_XFORMTYPE_PRF,	IKEV2_XFORMPRF_HMAC_SHA2_384 },
	{ IKEV2_XFORMTYPE_PRF,	IKEV2_XFORMPRF_HMAC_SHA2_512 },
	{ IKEV2_XFORMTYPE_PRF,	IKEV2_XFORMPRF_HMAC_SHA1 },
	{ IKEV2_XFORMTYPE_DH,	IKEV2_XFORMDH_CURVE25519 },
	{ IKEV2_XFORMTYPE_DH,	IKEV2_XFORMDH_ECP_521 },
	{ IKEV2_XFORMTYPE_DH,	IKEV2_XFORMDH_ECP_384 },
	{ IKEV2_XFORMTYPE_DH,	IKEV2_XFORMDH_ECP_256 },
	{ IKEV2_XFORMTYPE_DH,	IKEV2_XFORMDH_MODP_4096 },
	{ IKEV2_XFORMTYPE_DH,	IKEV2_XFORMDH_MODP_3072 },
	{ IKEV2_XFORMTYPE_DH,	IKEV2_XFORMDH_MODP_2048 },
	{ IKEV2_XFORMTYPE_DH,	IKEV2_XFORMDH_MODP_1536 },
	{ IKEV2_XFORMTYPE_DH,	IKEV2_XFORMDH_MODP_1024 },
	{ 0 }
};
size_t ikev2_default_nike_transforms_noauth =
    ((sizeof(ikev2_default_ike_transforms_noauth) /
    sizeof(ikev2_default_ike_transforms_noauth[0])) - 1);

struct iked_transform ikev2_default_esp_transforms[] = {
	{ IKEV2_XFORMTYPE_ENCR, IKEV2_XFORMENCR_AES_CBC, 256 },
	{ IKEV2_XFORMTYPE_ENCR, IKEV2_XFORMENCR_AES_CBC, 192 },
	{ IKEV2_XFORMTYPE_ENCR, IKEV2_XFORMENCR_AES_CBC, 128 },
	/* XXX: Linux uses a non-standard truncated SHA256 with pfkey */
#if !defined(HAVE_LINUX_PFKEY_H)
	{ IKEV2_XFORMTYPE_INTEGR, IKEV2_XFORMAUTH_HMAC_SHA2_256_128 },
#endif
	{ IKEV2_XFORMTYPE_INTEGR, IKEV2_XFORMAUTH_HMAC_SHA2_384_192 },
	{ IKEV2_XFORMTYPE_INTEGR, IKEV2_XFORMAUTH_HMAC_SHA2_512_256 },
	{ IKEV2_XFORMTYPE_INTEGR, IKEV2_XFORMAUTH_HMAC_SHA1_96 },
	{ IKEV2_XFORMTYPE_DH,	IKEV2_XFORMDH_NONE },
#if defined(SADB_X_SAFLAGS_ESN) && !defined(HAVE_APPLE_NATT)
	{ IKEV2_XFORMTYPE_ESN,	IKEV2_XFORMESN_ESN },
#endif
	{ IKEV2_XFORMTYPE_ESN,	IKEV2_XFORMESN_NONE },
	{ 0 }
};
size_t ikev2_default_nesp_transforms = ((sizeof(ikev2_default_esp_transforms) /
    sizeof(ikev2_default_esp_transforms[0])) - 1);

struct iked_transform ikev2_default_esp_transforms_noauth[] = {
	{ IKEV2_XFORMTYPE_ENCR,	IKEV2_XFORMENCR_AES_GCM_16, 128 },
	{ IKEV2_XFORMTYPE_ENCR,	IKEV2_XFORMENCR_AES_GCM_16, 256 },
	{ IKEV2_XFORMTYPE_DH,	IKEV2_XFORMDH_NONE },
#if defined(SADB_X_SAFLAGS_ESN) && !defined(HAVE_APPLE_NATT)
	{ IKEV2_XFORMTYPE_ESN,	IKEV2_XFORMESN_ESN },
#endif
	{ IKEV2_XFORMTYPE_ESN,	IKEV2_XFORMESN_NONE },
	{ 0 }
};
size_t ikev2_default_nesp_transforms_noauth =
    ((sizeof(ikev2_default_esp_transforms_noauth) /
    sizeof(ikev2_default_esp_transforms_noauth[0])) - 1);

const struct ipsec_xf authxfs[] = {
	{ "hmac-md5",		IKEV2_XFORMAUTH_HMAC_MD5_96,		16 },
	{ "hmac-sha1",		IKEV2_XFORMAUTH_HMAC_SHA1_96,		20 },
	{ "hmac-sha2-256",	IKEV2_XFORMAUTH_HMAC_SHA2_256_128,	32 },
	{ "hmac-sha2-384",	IKEV2_XFORMAUTH_HMAC_SHA2_384_192,	48 },
	{ "hmac-sha2-512",	IKEV2_XFORMAUTH_HMAC_SHA2_512_256,	64 },
	{ NULL }
};

const struct ipsec_xf prfxfs[] = {
	{ "hmac-md5",		IKEV2_XFORMPRF_HMAC_MD5,	16 },
	{ "hmac-sha1",		IKEV2_XFORMPRF_HMAC_SHA1,	20 },
	{ "hmac-sha2-256",	IKEV2_XFORMPRF_HMAC_SHA2_256,	32 },
	{ "hmac-sha2-384",	IKEV2_XFORMPRF_HMAC_SHA2_384,	48 },
	{ "hmac-sha2-512",	IKEV2_XFORMPRF_HMAC_SHA2_512,	64 },
	{ NULL }
};

const struct ipsec_xf *encxfs = NULL;

const struct ipsec_xf ikeencxfs[] = {
	{ "3des",		IKEV2_XFORMENCR_3DES,		24 },
	{ "3des-cbc",		IKEV2_XFORMENCR_3DES,		24 },
	{ "aes-128",		IKEV2_XFORMENCR_AES_CBC,	16, 16 },
	{ "aes-192",		IKEV2_XFORMENCR_AES_CBC,	24, 24 },
	{ "aes-256",		IKEV2_XFORMENCR_AES_CBC,	32, 32 },
	{ "aes-128-gcm",	IKEV2_XFORMENCR_AES_GCM_16,	16, 16, 4, 1 },
	{ "aes-256-gcm",	IKEV2_XFORMENCR_AES_GCM_16,	32, 32, 4, 1 },
	{ "aes-128-gcm-12",	IKEV2_XFORMENCR_AES_GCM_12,	16, 16, 4, 1 },
	{ "aes-256-gcm-12",	IKEV2_XFORMENCR_AES_GCM_12,	32, 32, 4, 1 },
	{ NULL }
};

const struct ipsec_xf ipsecencxfs[] = {
	{ "3des",		IKEV2_XFORMENCR_3DES,		24 },
	{ "3des-cbc",		IKEV2_XFORMENCR_3DES,		24 },
	{ "aes-128",		IKEV2_XFORMENCR_AES_CBC,	16, 16 },
	{ "aes-192",		IKEV2_XFORMENCR_AES_CBC,	24, 24 },
	{ "aes-256",		IKEV2_XFORMENCR_AES_CBC,	32, 32 },
	{ "aes-128-ctr",	IKEV2_XFORMENCR_AES_CTR,	16, 16, 4 },
	{ "aes-192-ctr",	IKEV2_XFORMENCR_AES_CTR,	24, 24, 4 },
	{ "aes-256-ctr",	IKEV2_XFORMENCR_AES_CTR,	32, 32, 4 },
	{ "aes-128-gcm",	IKEV2_XFORMENCR_AES_GCM_16,	16, 16, 4, 1 },
	{ "aes-192-gcm",	IKEV2_XFORMENCR_AES_GCM_16,	24, 24, 4, 1 },
	{ "aes-256-gcm",	IKEV2_XFORMENCR_AES_GCM_16,	32, 32, 4, 1 },
	{ "aes-128-gmac",	IKEV2_XFORMENCR_NULL_AES_GMAC,	16, 16, 4, 1 },
	{ "aes-192-gmac",	IKEV2_XFORMENCR_NULL_AES_GMAC,	24, 24, 4, 1 },
	{ "aes-256-gmac",	IKEV2_XFORMENCR_NULL_AES_GMAC,	32, 32, 4, 1 },
	{ "blowfish",		IKEV2_XFORMENCR_BLOWFISH,	20, 20 },
	{ "cast",		IKEV2_XFORMENCR_CAST,		16, 16 },
	{ "chacha20-poly1305",	IKEV2_XFORMENCR_CHACHA20_POLY1305,
								32, 32, 4, 1 },
	{ "null",		IKEV2_XFORMENCR_NULL,		0, 0 },
	{ NULL }
};

const struct ipsec_xf groupxfs[] = {
	{ "none",		IKEV2_XFORMDH_NONE },
	{ "modp768",		IKEV2_XFORMDH_MODP_768 },
	{ "grp1",		IKEV2_XFORMDH_MODP_768 },
	{ "modp1024",		IKEV2_XFORMDH_MODP_1024 },
	{ "grp2",		IKEV2_XFORMDH_MODP_1024 },
	{ "modp1536",		IKEV2_XFORMDH_MODP_1536 },
	{ "grp5",		IKEV2_XFORMDH_MODP_1536 },
	{ "modp2048",		IKEV2_XFORMDH_MODP_2048 },
	{ "grp14",		IKEV2_XFORMDH_MODP_2048 },
	{ "modp3072",		IKEV2_XFORMDH_MODP_3072 },
	{ "grp15",		IKEV2_XFORMDH_MODP_3072 },
	{ "modp4096",		IKEV2_XFORMDH_MODP_4096 },
	{ "grp16",		IKEV2_XFORMDH_MODP_4096 },
	{ "modp6144",		IKEV2_XFORMDH_MODP_6144 },
	{ "grp17",		IKEV2_XFORMDH_MODP_6144 },
	{ "modp8192",		IKEV2_XFORMDH_MODP_8192 },
	{ "grp18",		IKEV2_XFORMDH_MODP_8192 },
	{ "ecp256",		IKEV2_XFORMDH_ECP_256 },
	{ "grp19",		IKEV2_XFORMDH_ECP_256 },
	{ "ecp384",		IKEV2_XFORMDH_ECP_384 },
	{ "grp20",		IKEV2_XFORMDH_ECP_384 },
	{ "ecp521",		IKEV2_XFORMDH_ECP_521 },
	{ "grp21",		IKEV2_XFORMDH_ECP_521 },
	{ "ecp192",		IKEV2_XFORMDH_ECP_192 },
	{ "grp25",		IKEV2_XFORMDH_ECP_192 },
	{ "ecp224",		IKEV2_XFORMDH_ECP_224 },
	{ "grp26",		IKEV2_XFORMDH_ECP_224 },
	{ "brainpool224",	IKEV2_XFORMDH_BRAINPOOL_P224R1 },
	{ "grp27",		IKEV2_XFORMDH_BRAINPOOL_P224R1 },
	{ "brainpool256",	IKEV2_XFORMDH_BRAINPOOL_P256R1 },
	{ "grp28",		IKEV2_XFORMDH_BRAINPOOL_P256R1 },
	{ "brainpool384",	IKEV2_XFORMDH_BRAINPOOL_P384R1 },
	{ "grp29",		IKEV2_XFORMDH_BRAINPOOL_P384R1 },
	{ "brainpool512",	IKEV2_XFORMDH_BRAINPOOL_P512R1 },
	{ "grp30",		IKEV2_XFORMDH_BRAINPOOL_P512R1 },
	{ "curve25519",		IKEV2_XFORMDH_CURVE25519 },
	{ "grp31",		IKEV2_XFORMDH_CURVE25519 },
	{ "sntrup761x25519",	IKEV2_XFORMDH_X_SNTRUP761X25519 },
	{ NULL }
};

const struct ipsec_xf esnxfs[] = {
	{ "esn",		IKEV2_XFORMESN_ESN },
	{ "noesn",		IKEV2_XFORMESN_NONE },
	{ NULL }
};

const struct ipsec_xf methodxfs[] = {
	{ "none",		IKEV2_AUTH_NONE },
	{ "rsa",		IKEV2_AUTH_RSA_SIG },
	{ "ecdsa256",		IKEV2_AUTH_ECDSA_256 },
	{ "ecdsa384",		IKEV2_AUTH_ECDSA_384 },
	{ "ecdsa521",		IKEV2_AUTH_ECDSA_521 },
	{ "rfc7427",		IKEV2_AUTH_SIG },
	{ "signature",		IKEV2_AUTH_SIG_ANY },
	{ NULL }
};

const struct ipsec_xf saxfs[] = {
	{ "esp",		IKEV2_SAPROTO_ESP },
	{ "ah",			IKEV2_SAPROTO_AH },
	{ NULL }
};

const struct ipsec_xf cpxfs[] = {
	{ "address", IKEV2_CFG_INTERNAL_IP4_ADDRESS,		AF_INET },
	{ "netmask", IKEV2_CFG_INTERNAL_IP4_NETMASK,		AF_INET },
	{ "name-server", IKEV2_CFG_INTERNAL_IP4_DNS,		AF_INET },
	{ "netbios-server", IKEV2_CFG_INTERNAL_IP4_NBNS,	AF_INET },
	{ "dhcp-server", IKEV2_CFG_INTERNAL_IP4_DHCP,		AF_INET },
	{ "address", IKEV2_CFG_INTERNAL_IP6_ADDRESS,		AF_INET6 },
	{ "name-server", IKEV2_CFG_INTERNAL_IP6_DNS,		AF_INET6 },
	{ "netbios-server", IKEV2_CFG_INTERNAL_IP6_NBNS,	AF_INET6 },
	{ "dhcp-server", IKEV2_CFG_INTERNAL_IP6_DHCP,		AF_INET6 },
	{ "protected-subnet", IKEV2_CFG_INTERNAL_IP4_SUBNET,	AF_INET },
	{ "protected-subnet", IKEV2_CFG_INTERNAL_IP6_SUBNET,	AF_INET6 },
	{ "access-server", IKEV2_CFG_INTERNAL_IP4_SERVER,	AF_INET },
	{ "access-server", IKEV2_CFG_INTERNAL_IP6_SERVER,	AF_INET6 },
	{ NULL }
};

const struct iked_lifetime deflifetime = {
	IKED_LIFETIME_BYTES,
	IKED_LIFETIME_SECONDS
};

#define IPSEC_ADDR_ANY		(0x1)
#define IPSEC_ADDR_DYNAMIC	(0x2)

struct ipsec_addr_wrap {
	struct sockaddr_storage	 address;
	uint8_t			 mask;
	int			 netaddress;
	sa_family_t		 af;
	unsigned int		 type;
	unsigned int		 action;
	uint16_t		 port;
	char			*name;
	struct ipsec_addr_wrap	*next;
	struct ipsec_addr_wrap	*tail;
	struct ipsec_addr_wrap	*srcnat;
};

struct ipsec_hosts {
	struct ipsec_addr_wrap	*src;
	struct ipsec_addr_wrap	*dst;
};

struct ipsec_filters {
	char			*tag;
	unsigned int		 tap;
};

void			 copy_sockaddrtoipa(struct ipsec_addr_wrap *,
			    struct sockaddr *);
struct ipsec_addr_wrap	*host(const char *);
struct ipsec_addr_wrap	*host_ip(const char *, int);
struct ipsec_addr_wrap	*host_dns(const char *, int);
struct ipsec_addr_wrap	*host_if(const char *, int);
struct ipsec_addr_wrap	*host_any(void);
struct ipsec_addr_wrap	*host_dynamic(void);
void			 ifa_load(void);
int			 ifa_exists(const char *);
struct ipsec_addr_wrap	*ifa_lookup(const char *ifa_name);
struct ipsec_addr_wrap	*ifa_grouplookup(const char *);
void			 set_ipmask(struct ipsec_addr_wrap *, int);
const struct ipsec_xf	*parse_xf(const char *, unsigned int,
			    const struct ipsec_xf *);
void			 copy_transforms(unsigned int,
			    const struct ipsec_xf **, unsigned int,
			    struct iked_transform **, unsigned int *,
			    struct iked_transform *, size_t);
int			 create_ike(char *, int, struct ipsec_addr_wrap *,
			    int, struct ipsec_hosts *,
			    struct ipsec_hosts *, struct ipsec_mode *,
			    struct ipsec_mode *, uint8_t,
			    uint8_t, char *, char *,
			    uint32_t, struct iked_lifetime *,
			    struct iked_auth *, struct ipsec_filters *,
			    struct ipsec_addr_wrap *, char *);
int			 create_user(const char *, const char *);
int			 get_id_type(char *);
uint8_t			 x2i(unsigned char *);
int			 parsekey(unsigned char *, size_t, struct iked_auth *);
int			 parsekeyfile(char *, struct iked_auth *);
void			 iaw_free(struct ipsec_addr_wrap *);
static int		 create_flow(struct iked_policy *pol, int, struct ipsec_addr_wrap *ipa,
			    struct ipsec_addr_wrap *ipb);
static int		 expand_flows(struct iked_policy *, int, struct ipsec_addr_wrap *,
			    struct ipsec_addr_wrap *);
static struct ipsec_addr_wrap *
			 expand_keyword(struct ipsec_addr_wrap *);

struct ipsec_transforms *ipsec_transforms;
struct ipsec_filters *ipsec_filters;
struct ipsec_mode *ipsec_mode;
/* interface lookup routintes */
struct ipsec_addr_wrap	*iftab;

typedef struct {
	union {
		int64_t			 number;
		uint8_t			 ikemode;
		uint8_t			 dir;
		uint8_t			 satype;
		char			*string;
		uint16_t		 port;
		struct ipsec_hosts	*hosts;
		struct ipsec_hosts	 peers;
		struct ipsec_addr_wrap	*anyhost;
		struct ipsec_addr_wrap	*host;
		struct ipsec_addr_wrap	*cfg;
		struct ipsec_addr_wrap	*proto;
		struct {
			char		*srcid;
			char		*dstid;
		} ids;
		char			*id;
		uint8_t			 type;
		struct iked_lifetime	 lifetime;
		struct iked_auth	 ikeauth;
		struct iked_auth	 ikekey;
		struct ipsec_transforms	*transforms;
		struct ipsec_filters	*filters;
		struct ipsec_mode	*mode;
	} v;
	int lineno;
} YYSTYPE;

#line 443 "parse.c"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# define YYLEX_DECL() yylex(void *YYLEX_PARAM)
# define YYLEX yylex(YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(void)
# define YYLEX yylex()
#endif

#if !(defined(yylex) || defined(YYSTATE))
int YYLEX_DECL();
#endif

/* Parameters sent to yyerror. */
#ifndef YYERROR_DECL
#define YYERROR_DECL() yyerror(const char *s)
#endif
#ifndef YYERROR_CALL
#define YYERROR_CALL(msg) yyerror(msg)
#endif

extern int YYPARSE_DECL();

#define FROM 257
#define ESP 258
#define AH 259
#define IN 260
#define PEER 261
#define ON 262
#define OUT 263
#define TO 264
#define SRCID 265
#define DSTID 266
#define PSK 267
#define PORT 268
#define FILENAME 269
#define AUTHXF 270
#define PRFXF 271
#define ENCXF 272
#define ERROR 273
#define IKEV2 274
#define IKESA 275
#define CHILDSA 276
#define ESN 277
#define NOESN 278
#define PASSIVE 279
#define ACTIVE 280
#define ANY 281
#define TAG 282
#define TAP 283
#define PROTO 284
#define LOCAL 285
#define GROUP 286
#define NAME 287
#define CONFIG 288
#define EAP 289
#define USER 290
#define IKEV1 291
#define FLOW 292
#define SA 293
#define TCPMD5 294
#define TUNNEL 295
#define TRANSPORT 296
#define COUPLE 297
#define DECOUPLE 298
#define SET 299
#define INCLUDE 300
#define LIFETIME 301
#define BYTES 302
#define INET 303
#define INET6 304
#define QUICK 305
#define SKIP 306
#define DEFAULT 307
#define IPCOMP 308
#define OCSP 309
#define IKELIFETIME 310
#define MOBIKE 311
#define NOMOBIKE 312
#define RDOMAIN 313
#define FRAGMENTATION 314
#define NOFRAGMENTATION 315
#define DPD_CHECK_INTERVAL 316
#define ENFORCESINGLEIKESA 317
#define NOENFORCESINGLEIKESA 318
#define STICKYADDRESS 319
#define NOSTICKYADDRESS 320
#define VENDORID 321
#define NOVENDORID 322
#define TOLERATE 323
#define MAXAGE 324
#define DYNAMIC 325
#define CERTPARTIALCHAIN 326
#define REQUEST 327
#define IFACE 328
#define STRING 329
#define NUMBER 330
#define YYERRCODE 256
typedef int YYINT;
static const YYINT yylhs[] = {                           -1,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   46,
   46,   39,   40,   40,   40,   40,   40,   40,   40,   40,
   40,   40,   40,   40,   40,   40,   40,   40,   40,   40,
   40,   41,   42,   36,   36,   37,   37,   35,   35,   33,
   33,    2,    2,    2,   10,   10,   10,    3,    3,    3,
    4,    4,    5,    5,   11,   11,    7,    7,    6,    6,
    8,    8,    9,    9,   12,   12,   12,   12,   12,   13,
   13,   15,   15,   14,   14,   14,   14,   16,   16,   16,
   16,   17,   48,   18,   18,   47,   47,   49,   49,   49,
   49,   49,   38,   38,   51,   27,   27,   50,   50,   53,
   52,   55,   28,   28,   54,   54,   57,   56,   20,   21,
   21,   21,   21,   22,   22,   22,   23,   23,   24,   24,
   24,   25,   25,   25,   25,   30,   30,   31,   31,   29,
   29,   29,   32,   32,   26,   26,   59,   19,   19,   58,
   58,   60,   60,   34,   34,    1,    1,   43,   44,   44,
   44,   44,   61,   61,   61,   61,   61,   45,
};
static const YYINT yylen[] = {                            2,
    0,    3,    2,    3,    3,    3,    3,    4,    3,    1,
    0,    2,    2,    2,    2,    2,    2,    2,    2,    2,
    2,    2,    2,    2,    2,    2,    3,    5,    7,    2,
    3,    3,   18,    0,    1,    1,    2,    3,    3,    0,
    1,    0,    1,    1,    0,    1,    1,    0,    2,    4,
    1,    3,    1,    1,    0,    2,    1,    3,    6,    6,
    0,    2,    1,    1,    0,    4,    4,    2,    2,    1,
    1,    1,    3,    1,    4,    1,    1,    0,    4,    2,
    2,    1,    0,    2,    0,    2,    1,    2,    2,    2,
    2,    1,    1,    1,    0,    2,    0,    2,    1,    0,
    3,    0,    2,    0,    2,    1,    0,    3,    4,    0,
    1,    1,    1,    0,    1,    1,    0,    1,    0,    1,
    1,    0,    2,    2,    1,    1,    1,    1,    1,    0,
    2,    4,    0,    2,    1,    2,    0,    2,    0,    2,
    1,    2,    2,    0,    2,    2,    1,    3,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    0,
};
static const YYINT yydefred[] = {                         1,
    0,    0,  154,  155,    0,    0,  149,  151,  153,  152,
  156,  157,    0,    0,    0,    3,    0,    0,    0,    0,
    0,  158,  150,    9,   41,    0,    0,   14,   13,   15,
   16,    0,   19,   20,   17,   18,    0,   23,   24,   25,
   26,   21,   22,   30,   12,    0,    2,    4,    5,    6,
    7,    0,  111,  112,  113,    0,    0,   32,    0,   31,
  147,    0,    8,   43,   44,    0,  115,  116,    0,    0,
  146,   46,   47,    0,  118,    0,  129,  128,    0,    0,
    0,  120,  121,  109,    0,   53,   54,    0,   49,    0,
    0,   29,    0,   51,   56,    0,    0,   57,    0,   10,
   50,    0,   76,   77,    0,    0,    0,    0,    0,    0,
    0,    0,   52,    0,    0,    0,    0,    0,   71,    0,
   70,    0,    0,    0,   58,   73,   63,   64,   62,    0,
    0,    0,    0,    0,    0,    0,  100,    0,   99,    0,
   75,    0,   66,   67,    0,    0,    0,  107,    0,  106,
    0,   98,   59,   60,   82,    0,   81,    0,    0,    0,
  105,  101,    0,    0,  134,    0,    0,  108,    0,    0,
    0,   93,   94,    0,   92,    0,   87,   79,    0,    0,
    0,  125,    0,   88,   90,   89,   91,   86,    0,    0,
  135,  123,  124,    0,    0,   36,    0,    0,  127,  126,
  132,  136,    0,    0,    0,    0,   37,   38,   39,  145,
   33,    0,    0,    0,    0,  141,  142,  143,  140,
};
#if defined(YYDESTRUCT_CALL) || defined(YYSTYPE_TOSTRING)
static const YYINT yystos[] = {                           0,
  332,  256,  257,  264,  274,  290,  291,  292,  293,  294,
  295,  296,  299,  300,  329,   10,  371,  372,  373,  374,
  375,  376,  393,   10,  329,  365,  329,  279,  280,  297,
  298,  309,  311,  312,  314,  315,  316,  317,  318,  319,
  320,  321,  322,  326,  329,   61,   10,   10,   10,   10,
   10,  377,  305,  306,  307,  352,  353,  329,  329,  330,
  329,  333,   10,  258,  259,  334,  279,  280,  354,  323,
  329,  303,  304,  342,  308,  355,  329,  330,  363,  284,
  335,  295,  296,  356,  324,  329,  330,  123,  337,  313,
  343,  363,  336,  337,  330,  257,  264,  338,  339,   44,
  125,  378,  281,  325,  329,  346,  347,  346,  261,  285,
  344,  378,  337,   47,  268,  340,   40,  340,  281,  345,
  347,  345,  359,  383,  338,  330,  329,  330,  341,  264,
  347,  257,  285,  261,  360,  387,  275,  382,  384,  346,
   41,  346,  345,  345,  265,  266,  348,  276,  386,  388,
  385,  384,  340,  340,  329,  349,  349,  310,  364,  389,
  388,  350,  380,  266,  363,  301,  361,  350,  270,  271,
  272,  277,  278,  286,  370,  379,  381,  349,  363,  267,
  289,  329,  357,  329,  329,  329,  329,  381,  302,  269,
  329,  358,  329,  288,  327,  367,  368,  369,  329,  330,
  362,  329,  329,  329,  328,  366,  367,  347,  345,  329,
  351,  391,  282,  283,  390,  392,  329,  329,  392,
};
#endif /* YYDESTRUCT_CALL || YYSTYPE_TOSTRING */
static const YYINT yydgoto[] = {                          1,
   62,   66,   81,   93,   89,   98,   99,  116,  129,   74,
   91,  111,  120,  106,  121,  147,  156,  162,  211,   56,
   57,   69,   76,   84,  183,  192,  123,  135,  167,  201,
   79,  159,   26,  206,  196,  197,  198,  175,   17,   18,
   19,   20,   21,   22,   52,  102,  176,  163,  177,  138,
  124,  139,  151,  149,  136,  150,  160,  215,  212,  216,
   23,
};
static const YYINT yysindex[] = {                         0,
  184,   25,    0,    0, -290, -282,    0,    0,    0,    0,
    0,    0,  399, -276,   24,    0,   70,   81,   86,   92,
   98,    0,    0,    0,    0, -262, -206,    0,    0,    0,
    0, -192,    0,    0,    0,    0, -214,    0,    0,    0,
    0,    0,    0,    0,    0, -188,    0,    0,    0,    0,
    0,  116,    0,    0,    0, -235, -260,    0, -189,    0,
    0, -172,    0,    0,    0, -229,    0,    0, -165, -253,
    0,    0,    0, -117,    0, -201,    0,    0, -158, -121,
 -144,    0,    0,    0, -253,    0,    0, -231,    0, -160,
 -195,    0,  -37,    0,    0, -239, -239,    0,  -43,    0,
    0, -231,    0,    0,  127,  -93,  136,  -93, -269, -269,
    0, -195,    0, -152, -223,  -87, -150,  -77,    0, -103,
    0,  -75,    0,  -88,    0,    0,    0,    0,    0, -239,
  147, -239, -269, -269, -153,  -86,    0,  -88,    0,  -93,
    0,  -93,    0,    0, -136, -136, -115,    0,  -86,    0,
    0,    0,    0,    0,    0,  -69,    0, -253, -102,    0,
    0,    0, -213, -136,    0, -253, -257,    0, -131, -129,
 -127,    0,    0, -126,    0, -213,    0,    0, -113, -261,
 -123,    0, -275,    0,    0,    0,    0,    0, -194, -122,
    0,    0,    0, -119, -116,    0, -111, -275,    0,    0,
    0,    0, -150, -269, -114,    0,    0,    0,    0,    0,
    0, -133, -110, -109, -133,    0,    0,    0,    0,
};
static const YYINT yyrindex[] = {                         0,
    0,    0,    0,    0, -175,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, -140,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, -142, -112,    0,  201,    0,
    0,  202,    0,    0,    0, -243,    0,    0, -203,    0,
    0,    0,    0, -246,    0,  -99,    0,    0,  206,    0,
 -186,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, -176,    0,    0,    0,    0,    0,  171,    0,
    0,    0,    0,    0,  -10,  -42,   19,  -36,    0,    0,
  220,    0,    0,    0,    0,    0,    0,    0,    0,  240,
    0,  288,  353,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  251,    0,    0,  357,    0,  104,
    0,  104,    0,    0,    0,    0,   23,    0,   93,    0,
   56,    0,    0,    0,    0,  343,    0,    0,  406,  141,
    0,    0,    0,    0,    0,    0,   27,    0,    0,    0,
    0,    0,    0,    0,    0,  320,    0,    0,  416,    0,
    0,    0,  115,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   -1,  117,    0,    0,
    0,    0,    0,    0,    0,    6,    0,    0,    0,    0,
    0,    0,    0,    0,  213,    0,    0,    0,    0,
};
#if YYBTYACC
static const YYINT yycindex[] = {                         0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,
};
#endif
static const YYINT yygindex[] = {                         0,
    0,    0,    0,    0,  -66,  112,    0,  -91,    0,    0,
    0,    0, -107,  -82,  -92,    0, -118,   65,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  -79,    0,    0,    0,   28,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  128,    0,    0,   52,    0,
    0,   91,    0,    0,    0,   82,    0,    0,    0,   17,
    0,
};
#define YYTABLESIZE 745
static const YYINT yytable[] = {                         72,
  100,   88,  122,  107,  107,   92,  100,  190,  144,  180,
   48,  119,  194,   45,  108,  139,  118,   48,   67,   68,
   45,   94,   64,   65,  131,  143,  144,  157,   74,   72,
   72,  181,  133,   72,   24,  113,  122,  107,   25,  107,
   45,  103,   53,   54,   55,  178,   27,  140,  153,  142,
  154,  195,   45,  117,  117,  117,  169,  170,  171,  105,
  117,   96,   74,  172,  173,   85,   48,  191,   97,   45,
   55,  182,  174,   72,   73,   77,   78,   55,  165,   47,
  117,   40,   40,   40,   46,  104,  179,  101,   40,  105,
   48,  117,  117,   82,   83,   49,  209,   86,   87,  117,
  117,   50,  103,   40,   40,  127,  128,   51,   40,  117,
  208,  145,  146,   61,   42,   60,  110,  110,  110,   40,
   40,   42,   58,  110,   34,   63,   35,   40,   40,   40,
   40,   40,   40,   70,  199,  200,   59,   40,  110,  110,
   61,   42,   75,  110,  114,  114,  114,   61,  213,  214,
   85,  114,   11,   11,  110,  110,   71,  119,  119,  119,
   42,   42,  110,  110,  119,   85,   80,  110,   90,   95,
   42,  114,  110,  114,  115,  117,  130,  126,  105,  132,
   65,  133,  114,  114,  119,  134,  137,  141,  189,  148,
  114,  114,  155,   16,  158,  114,  164,  184,  166,  185,
  114,  186,  187,  119,  119,  193,  202,   86,   87,  203,
   27,  148,  204,  119,  210,   28,  205,  109,  217,  218,
   61,   61,  138,  125,  168,  207,  112,  188,  152,   97,
  161,  219,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  110,    0,    0,    0,    0,   72,    0,    0,   68,
   72,    0,    0,   72,   72,   72,   72,   72,    0,    0,
   78,    0,    0,    0,   72,   72,    0,    0,    0,    0,
    0,   72,   72,    0,   72,   74,    0,   72,   72,   74,
  144,  144,   74,   74,   74,   74,   74,  137,  137,  133,
   72,    0,    0,   74,   74,    0,    0,   69,    0,   72,
   74,   74,    0,   74,  133,  133,   74,   74,  122,  122,
  133,  133,    0,    0,  122,    0,   72,   72,   72,   74,
   85,   85,   85,  133,    0,   83,   83,   83,   74,   84,
   85,   85,   83,   83,    0,    0,    0,   85,   85,    0,
    0,   83,    0,   85,   85,   74,   74,   74,    0,  133,
  133,  133,   80,  122,  122,    0,   85,  103,  103,  103,
   61,    0,  104,    0,   61,   85,   96,   61,   61,   61,
   61,    0,    0,    0,  103,  103,    0,    0,   61,   61,
  103,  103,   85,   85,   85,   61,   61,    0,   61,    0,
    0,   61,   61,  103,    0,    0,   34,   34,   35,   35,
    0,    0,  103,    0,   61,   85,   85,   85,    0,    0,
   83,   83,   83,   61,    0,  130,   85,   83,   83,  103,
  103,  103,   85,   85,    0,  131,   83,   11,   85,   85,
   61,   61,   61,    0,   11,   65,   65,   65,    0,    2,
    3,   85,   34,    0,   35,   65,   65,    4,    0,    0,
   85,    0,   65,   65,    0,    0,    0,    5,   65,   65,
    0,    0,    0,    0,    0,    0,    0,   85,   85,   85,
    0,   65,    0,    6,    7,    8,    9,   10,   11,   12,
   65,    0,   13,   14,   97,   97,   97,    0,    0,    0,
    0,    0,    0,    0,   95,   97,    0,   65,   65,   65,
    0,   97,   97,    0,   68,   68,   68,   97,   97,    0,
    0,    0,   15,    0,   68,   68,    0,   78,    0,    0,
   97,   68,   68,    0,    0,    0,    0,   68,   68,   97,
    0,    0,   78,   78,    0,    0,    0,    0,   78,   78,
   68,    0,    0,    0,    0,    0,   97,   97,   97,   68,
    0,   78,   69,   69,   69,    0,    0,    0,    0,    0,
   78,    0,   69,   69,    0,    0,   68,   68,   68,   69,
   69,    0,    0,    0,    0,   69,   69,   78,   78,   78,
    0,    0,    0,    0,   84,   84,   84,    0,   69,    0,
    0,    0,    0,    0,   84,   84,    0,   69,    0,    0,
    0,   84,   84,    0,    0,    0,    0,   84,   84,   80,
    0,    0,    0,    0,   69,   69,   69,  104,  104,  104,
   84,   96,   96,   96,   80,   80,    0,    0,  102,   84,
   80,   80,   96,    0,  104,  104,    0,    0,   96,   96,
  104,  104,    0,   80,   96,   96,   84,   84,   84,    0,
    0,    0,   80,  104,    0,    0,    0,   96,    0,    0,
    0,    0,  104,    0,    0,    0,   96,    0,    0,   80,
   80,   80,  130,    0,    0,    0,    0,   28,   29,  104,
  104,  104,  131,   96,   96,   96,    0,  130,  130,    0,
    0,    0,    0,  130,  130,   30,   31,  131,  131,    0,
    0,    0,    0,  131,  131,    0,    0,   32,    0,   33,
   34,    0,   35,   36,   37,   38,   39,   40,   41,   42,
   43,    0,    0,    0,   44,    0,    0,    0,    0,    0,
    0,    0,  130,  130,  130,    0,    0,    0,    0,    0,
    0,    0,  131,  131,  131,
};
static const YYINT yycheck[] = {                         10,
   44,  123,  110,   96,   97,   85,   44,  269,   10,  267,
  257,  281,  288,  257,   97,   10,  108,  264,  279,  280,
  264,   88,  258,  259,  117,  133,  134,  146,   10,   40,
   41,  289,   10,   44,   10,  102,   10,  130,  329,  132,
  284,  281,  305,  306,  307,  164,  329,  130,  140,  132,
  142,  327,  329,  257,  258,  259,  270,  271,  272,  329,
  264,  257,   44,  277,  278,   10,  313,  329,  264,  313,
  257,  329,  286,  303,  304,  329,  330,  264,  158,   10,
  284,  257,  258,  259,   61,  325,  166,  125,  264,  329,
   10,  295,  296,  295,  296,   10,  204,  329,  330,  303,
  304,   10,   10,  279,  280,  329,  330,   10,  284,  313,
  203,  265,  266,   10,  257,  330,  257,  258,  259,  295,
  296,  264,  329,  264,   10,   10,   10,  303,  304,  305,
  306,  307,  308,  323,  329,  330,  329,  313,  279,  280,
  329,  284,  308,  284,  257,  258,  259,   44,  282,  283,
   10,  264,  329,  330,  295,  296,  329,  257,  258,  259,
  303,  304,  303,  304,  264,  324,  284,  308,  313,  330,
  313,  284,  313,   47,  268,   40,  264,  330,  329,  257,
   10,  285,  295,  296,  284,  261,  275,   41,  302,  276,
  303,  304,  329,   10,  310,  308,  266,  329,  301,  329,
  313,  329,  329,  303,  304,  329,  329,  329,  330,  329,
   10,   10,  329,  313,  329,   10,  328,  261,  329,  329,
  257,  264,   10,  112,  160,  198,   99,  176,  138,   10,
  149,  215,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  285,   -1,   -1,   -1,   -1,  257,   -1,   -1,   10,
  261,   -1,   -1,  264,  265,  266,  267,  268,   -1,   -1,
   10,   -1,   -1,   -1,  275,  276,   -1,   -1,   -1,   -1,
   -1,  282,  283,   -1,  285,  257,   -1,  288,  289,  261,
  282,  283,  264,  265,  266,  267,  268,  282,  283,  267,
  301,   -1,   -1,  275,  276,   -1,   -1,   10,   -1,  310,
  282,  283,   -1,  285,  282,  283,  288,  289,  282,  283,
  288,  289,   -1,   -1,  288,   -1,  327,  328,  329,  301,
  265,  266,  267,  301,   -1,  270,  271,  272,  310,   10,
  275,  276,  277,  278,   -1,   -1,   -1,  282,  283,   -1,
   -1,  286,   -1,  288,  289,  327,  328,  329,   -1,  327,
  328,  329,   10,  327,  328,   -1,  301,  265,  266,  267,
  257,   -1,   10,   -1,  261,  310,   10,  264,  265,  266,
  267,   -1,   -1,   -1,  282,  283,   -1,   -1,  275,  276,
  288,  289,  327,  328,  329,  282,  283,   -1,  285,   -1,
   -1,  288,  289,  301,   -1,   -1,  282,  283,  282,  283,
   -1,   -1,  310,   -1,  301,  265,  266,  267,   -1,   -1,
  270,  271,  272,  310,   -1,   10,  276,  277,  278,  327,
  328,  329,  282,  283,   -1,   10,  286,  257,  288,  289,
  327,  328,  329,   -1,  264,  265,  266,  267,   -1,  256,
  257,  301,  328,   -1,  328,  275,  276,  264,   -1,   -1,
  310,   -1,  282,  283,   -1,   -1,   -1,  274,  288,  289,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  327,  328,  329,
   -1,  301,   -1,  290,  291,  292,  293,  294,  295,  296,
  310,   -1,  299,  300,  265,  266,  267,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  275,  276,   -1,  327,  328,  329,
   -1,  282,  283,   -1,  265,  266,  267,  288,  289,   -1,
   -1,   -1,  329,   -1,  275,  276,   -1,  267,   -1,   -1,
  301,  282,  283,   -1,   -1,   -1,   -1,  288,  289,  310,
   -1,   -1,  282,  283,   -1,   -1,   -1,   -1,  288,  289,
  301,   -1,   -1,   -1,   -1,   -1,  327,  328,  329,  310,
   -1,  301,  265,  266,  267,   -1,   -1,   -1,   -1,   -1,
  310,   -1,  275,  276,   -1,   -1,  327,  328,  329,  282,
  283,   -1,   -1,   -1,   -1,  288,  289,  327,  328,  329,
   -1,   -1,   -1,   -1,  265,  266,  267,   -1,  301,   -1,
   -1,   -1,   -1,   -1,  275,  276,   -1,  310,   -1,   -1,
   -1,  282,  283,   -1,   -1,   -1,   -1,  288,  289,  267,
   -1,   -1,   -1,   -1,  327,  328,  329,  265,  266,  267,
  301,  265,  266,  267,  282,  283,   -1,   -1,  276,  310,
  288,  289,  276,   -1,  282,  283,   -1,   -1,  282,  283,
  288,  289,   -1,  301,  288,  289,  327,  328,  329,   -1,
   -1,   -1,  310,  301,   -1,   -1,   -1,  301,   -1,   -1,
   -1,   -1,  310,   -1,   -1,   -1,  310,   -1,   -1,  327,
  328,  329,  267,   -1,   -1,   -1,   -1,  279,  280,  327,
  328,  329,  267,  327,  328,  329,   -1,  282,  283,   -1,
   -1,   -1,   -1,  288,  289,  297,  298,  282,  283,   -1,
   -1,   -1,   -1,  288,  289,   -1,   -1,  309,   -1,  311,
  312,   -1,  314,  315,  316,  317,  318,  319,  320,  321,
  322,   -1,   -1,   -1,  326,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  327,  328,  329,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  327,  328,  329,
};
#if YYBTYACC
static const YYINT yyctable[] = {                        -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,
};
#endif
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 330
#define YYUNDFTOKEN 394
#define YYTRANSLATE(a) ((a) > YYMAXTOKEN ? YYUNDFTOKEN : (a))
#if YYDEBUG
static const char *const yyname[] = {

"$end",0,0,0,0,0,0,0,0,0,"'\\n'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'('","')'",0,0,"','",0,0,"'/'",0,0,0,0,0,0,0,0,0,0,0,0,0,"'='",0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"'{'",0,"'}'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"error",
"FROM","ESP","AH","IN","PEER","ON","OUT","TO","SRCID","DSTID","PSK","PORT",
"FILENAME","AUTHXF","PRFXF","ENCXF","ERROR","IKEV2","IKESA","CHILDSA","ESN",
"NOESN","PASSIVE","ACTIVE","ANY","TAG","TAP","PROTO","LOCAL","GROUP","NAME",
"CONFIG","EAP","USER","IKEV1","FLOW","SA","TCPMD5","TUNNEL","TRANSPORT",
"COUPLE","DECOUPLE","SET","INCLUDE","LIFETIME","BYTES","INET","INET6","QUICK",
"SKIP","DEFAULT","IPCOMP","OCSP","IKELIFETIME","MOBIKE","NOMOBIKE","RDOMAIN",
"FRAGMENTATION","NOFRAGMENTATION","DPD_CHECK_INTERVAL","ENFORCESINGLEIKESA",
"NOENFORCESINGLEIKESA","STICKYADDRESS","NOSTICKYADDRESS","VENDORID",
"NOVENDORID","TOLERATE","MAXAGE","DYNAMIC","CERTPARTIALCHAIN","REQUEST","IFACE",
"STRING","NUMBER","$accept","grammar","string","satype","proto","proto_list",
"protoval","hosts","hosts_list","port","portval","af","rdomain","peers",
"anyhost","host","host_spec","ids","id","transforms","filters","ikeflags",
"ikematch","ikemode","ipcomp","tmode","ikeauth","keyspec","ike_sas","child_sas",
"lifetime","byte_spec","time_spec","ikelifetime","name","iface","cfg","ikecfg",
"ikecfgvals","transform_esn","include","set","user","ikev2rule","varset",
"otherrule","skipline","comma","transforms_l","$$1","transform","ike_sas_l",
"$$2","ike_sa","$$3","child_sas_l","$$4","child_sa","$$5","filters_l","$$6",
"filter","sarule","illegal-symbol",
};
static const char *const yyrule[] = {
"$accept : grammar",
"grammar :",
"grammar : grammar include '\\n'",
"grammar : grammar '\\n'",
"grammar : grammar set '\\n'",
"grammar : grammar user '\\n'",
"grammar : grammar ikev2rule '\\n'",
"grammar : grammar varset '\\n'",
"grammar : grammar otherrule skipline '\\n'",
"grammar : grammar error '\\n'",
"comma : ','",
"comma :",
"include : INCLUDE STRING",
"set : SET ACTIVE",
"set : SET PASSIVE",
"set : SET COUPLE",
"set : SET DECOUPLE",
"set : SET FRAGMENTATION",
"set : SET NOFRAGMENTATION",
"set : SET MOBIKE",
"set : SET NOMOBIKE",
"set : SET VENDORID",
"set : SET NOVENDORID",
"set : SET ENFORCESINGLEIKESA",
"set : SET NOENFORCESINGLEIKESA",
"set : SET STICKYADDRESS",
"set : SET NOSTICKYADDRESS",
"set : SET OCSP STRING",
"set : SET OCSP STRING TOLERATE time_spec",
"set : SET OCSP STRING TOLERATE time_spec MAXAGE time_spec",
"set : SET CERTPARTIALCHAIN",
"set : SET DPD_CHECK_INTERVAL NUMBER",
"user : USER STRING STRING",
"ikev2rule : IKEV2 name ikeflags satype af proto rdomain hosts_list peers ike_sas child_sas ids ikelifetime lifetime ikeauth ikecfg iface filters",
"ikecfg :",
"ikecfg : ikecfgvals",
"ikecfgvals : cfg",
"ikecfgvals : ikecfgvals cfg",
"cfg : CONFIG STRING host_spec",
"cfg : REQUEST STRING anyhost",
"name :",
"name : STRING",
"satype :",
"satype : ESP",
"satype : AH",
"af :",
"af : INET",
"af : INET6",
"proto :",
"proto : PROTO protoval",
"proto : PROTO '{' proto_list '}'",
"proto_list : protoval",
"proto_list : proto_list comma protoval",
"protoval : STRING",
"protoval : NUMBER",
"rdomain :",
"rdomain : RDOMAIN NUMBER",
"hosts_list : hosts",
"hosts_list : hosts_list comma hosts",
"hosts : FROM host port TO host port",
"hosts : TO host port FROM host port",
"port :",
"port : PORT portval",
"portval : STRING",
"portval : NUMBER",
"peers :",
"peers : PEER anyhost LOCAL anyhost",
"peers : LOCAL anyhost PEER anyhost",
"peers : PEER anyhost",
"peers : LOCAL anyhost",
"anyhost : host_spec",
"anyhost : ANY",
"host_spec : STRING",
"host_spec : STRING '/' NUMBER",
"host : host_spec",
"host : host_spec '(' host_spec ')'",
"host : ANY",
"host : DYNAMIC",
"ids :",
"ids : SRCID id DSTID id",
"ids : SRCID id",
"ids : DSTID id",
"id : STRING",
"$$1 :",
"transforms : $$1 transforms_l",
"transforms :",
"transforms_l : transforms_l transform",
"transforms_l : transform",
"transform : AUTHXF STRING",
"transform : ENCXF STRING",
"transform : PRFXF STRING",
"transform : GROUP STRING",
"transform : transform_esn",
"transform_esn : ESN",
"transform_esn : NOESN",
"$$2 :",
"ike_sas : $$2 ike_sas_l",
"ike_sas :",
"ike_sas_l : ike_sas_l ike_sa",
"ike_sas_l : ike_sa",
"$$3 :",
"ike_sa : IKESA $$3 transforms",
"$$4 :",
"child_sas : $$4 child_sas_l",
"child_sas :",
"child_sas_l : child_sas_l child_sa",
"child_sas_l : child_sa",
"$$5 :",
"child_sa : CHILDSA $$5 transforms",
"ikeflags : ikematch ikemode ipcomp tmode",
"ikematch :",
"ikematch : QUICK",
"ikematch : SKIP",
"ikematch : DEFAULT",
"ikemode :",
"ikemode : PASSIVE",
"ikemode : ACTIVE",
"ipcomp :",
"ipcomp : IPCOMP",
"tmode :",
"tmode : TUNNEL",
"tmode : TRANSPORT",
"ikeauth :",
"ikeauth : PSK keyspec",
"ikeauth : EAP STRING",
"ikeauth : STRING",
"byte_spec : NUMBER",
"byte_spec : STRING",
"time_spec : NUMBER",
"time_spec : STRING",
"lifetime :",
"lifetime : LIFETIME time_spec",
"lifetime : LIFETIME time_spec BYTES byte_spec",
"ikelifetime :",
"ikelifetime : IKELIFETIME time_spec",
"keyspec : STRING",
"keyspec : FILENAME STRING",
"$$6 :",
"filters : $$6 filters_l",
"filters :",
"filters_l : filters_l filter",
"filters_l : filter",
"filter : TAG STRING",
"filter : TAP STRING",
"iface :",
"iface : IFACE STRING",
"string : string STRING",
"string : STRING",
"varset : STRING '=' string",
"otherrule : IKEV1",
"otherrule : sarule",
"otherrule : FLOW",
"otherrule : TCPMD5",
"sarule : SA",
"sarule : FROM",
"sarule : TO",
"sarule : TUNNEL",
"sarule : TRANSPORT",
"skipline :",

};
#endif

#if YYDEBUG
int      yydebug;
#endif

int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;
int      yynerrs;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
YYLTYPE  yyloc; /* position returned by actions */
YYLTYPE  yylloc; /* position from the lexer */
#endif

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
#ifndef YYLLOC_DEFAULT
#define YYLLOC_DEFAULT(loc, rhs, n) \
do \
{ \
    if (n == 0) \
    { \
        (loc).first_line   = YYRHSLOC(rhs, 0).last_line; \
        (loc).first_column = YYRHSLOC(rhs, 0).last_column; \
        (loc).last_line    = YYRHSLOC(rhs, 0).last_line; \
        (loc).last_column  = YYRHSLOC(rhs, 0).last_column; \
    } \
    else \
    { \
        (loc).first_line   = YYRHSLOC(rhs, 1).first_line; \
        (loc).first_column = YYRHSLOC(rhs, 1).first_column; \
        (loc).last_line    = YYRHSLOC(rhs, n).last_line; \
        (loc).last_column  = YYRHSLOC(rhs, n).last_column; \
    } \
} while (0)
#endif /* YYLLOC_DEFAULT */
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#if YYBTYACC

#ifndef YYLVQUEUEGROWTH
#define YYLVQUEUEGROWTH 32
#endif
#endif /* YYBTYACC */

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH  10000
#endif
#endif

#ifndef YYINITSTACKSIZE
#define YYINITSTACKSIZE 200
#endif

typedef struct {
    unsigned stacksize;
    YYINT    *s_base;
    YYINT    *s_mark;
    YYINT    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE  *p_base;
    YYLTYPE  *p_mark;
#endif
} YYSTACKDATA;
#if YYBTYACC

struct YYParseState_s
{
    struct YYParseState_s *save;    /* Previously saved parser state */
    YYSTACKDATA            yystack; /* saved parser stack */
    int                    state;   /* saved parser state */
    int                    errflag; /* saved error recovery status */
    int                    lexeme;  /* saved index of the conflict lexeme in the lexical queue */
    YYINT                  ctry;    /* saved index in yyctable[] for this conflict */
};
typedef struct YYParseState_s YYParseState;
#endif /* YYBTYACC */
/* variables for the parser stack */
static YYSTACKDATA yystack;
#if YYBTYACC

/* Current parser state */
static YYParseState *yyps = 0;

/* yypath != NULL: do the full parse, starting at *yypath parser state. */
static YYParseState *yypath = 0;

/* Base of the lexical value queue */
static YYSTYPE *yylvals = 0;

/* Current position at lexical value queue */
static YYSTYPE *yylvp = 0;

/* End position of lexical value queue */
static YYSTYPE *yylve = 0;

/* The last allocated position at the lexical value queue */
static YYSTYPE *yylvlim = 0;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
/* Base of the lexical position queue */
static YYLTYPE *yylpsns = 0;

/* Current position at lexical position queue */
static YYLTYPE *yylpp = 0;

/* End position of lexical position queue */
static YYLTYPE *yylpe = 0;

/* The last allocated position at the lexical position queue */
static YYLTYPE *yylplim = 0;
#endif

/* Current position at lexical token queue */
static YYINT  *yylexp = 0;

static YYINT  *yylexemes = 0;
#endif /* YYBTYACC */
#line 1314 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"

struct keywords {
	const char	*k_name;
	int		 k_val;
};

void
copy_sockaddrtoipa(struct ipsec_addr_wrap *ipa, struct sockaddr *sa)
{
	if (sa->sa_family == AF_INET6)
		memcpy(&ipa->address, sa, sizeof(struct sockaddr_in6));
	else if (sa->sa_family == AF_INET)
		memcpy(&ipa->address, sa, sizeof(struct sockaddr_in));
	else
		warnx("unhandled af %d", sa->sa_family);
}

int
yyerror(const char *fmt, ...)
{
	va_list		 ap;

	file->errors++;
	va_start(ap, fmt);
	fprintf(stderr, "%s: %d: ", file->name, yylval.lineno);
	vfprintf(stderr, fmt, ap);
	fprintf(stderr, "\n");
	va_end(ap);
	return (0);
}

int
kw_cmp(const void *k, const void *e)
{
	return (strcmp(k, ((const struct keywords *)e)->k_name));
}

int
lookup(char *s)
{
	/* this has to be sorted always */
	static const struct keywords keywords[] = {
		{ "active",		ACTIVE },
		{ "ah",			AH },
		{ "any",		ANY },
		{ "auth",		AUTHXF },
		{ "bytes",		BYTES },
		{ "cert_partial_chain",	CERTPARTIALCHAIN },
		{ "childsa",		CHILDSA },
		{ "config",		CONFIG },
		{ "couple",		COUPLE },
		{ "decouple",		DECOUPLE },
		{ "default",		DEFAULT },
		{ "dpd_check_interval",	DPD_CHECK_INTERVAL },
		{ "dstid",		DSTID },
		{ "dynamic",		DYNAMIC },
		{ "eap",		EAP },
		{ "enc",		ENCXF },
		{ "enforcesingleikesa",	ENFORCESINGLEIKESA },
		{ "esn",		ESN },
		{ "esp",		ESP },
		{ "file",		FILENAME },
		{ "flow",		FLOW },
		{ "fragmentation",	FRAGMENTATION },
		{ "from",		FROM },
		{ "group",		GROUP },
		{ "iface",		IFACE },
		{ "ike",		IKEV1 },
		{ "ikelifetime",	IKELIFETIME },
		{ "ikesa",		IKESA },
		{ "ikev2",		IKEV2 },
		{ "include",		INCLUDE },
		{ "inet",		INET },
		{ "inet6",		INET6 },
		{ "ipcomp",		IPCOMP },
		{ "lifetime",		LIFETIME },
		{ "local",		LOCAL },
		{ "maxage",		MAXAGE },
		{ "mobike",		MOBIKE },
		{ "name",		NAME },
		{ "noenforcesingleikesa",	NOENFORCESINGLEIKESA },
		{ "noesn",		NOESN },
		{ "nofragmentation",	NOFRAGMENTATION },
		{ "nomobike",		NOMOBIKE },
		{ "nostickyaddress",	NOSTICKYADDRESS },
		{ "novendorid",		NOVENDORID },
		{ "ocsp",		OCSP },
		{ "passive",		PASSIVE },
		{ "peer",		PEER },
		{ "port",		PORT },
		{ "prf",		PRFXF },
		{ "proto",		PROTO },
		{ "psk",		PSK },
		{ "quick",		QUICK },
		{ "rdomain",		RDOMAIN },
		{ "request",		REQUEST },
		{ "sa",			SA },
		{ "set",		SET },
		{ "skip",		SKIP },
		{ "srcid",		SRCID },
		{ "stickyaddress",	STICKYADDRESS },
		{ "tag",		TAG },
		{ "tap",		TAP },
		{ "tcpmd5",		TCPMD5 },
		{ "to",			TO },
		{ "tolerate",		TOLERATE },
		{ "transport",		TRANSPORT },
		{ "tunnel",		TUNNEL },
		{ "user",		USER },
		{ "vendorid",		VENDORID }
	};
	const struct keywords	*p;

	p = bsearch(s, keywords, sizeof(keywords)/sizeof(keywords[0]),
	    sizeof(keywords[0]), kw_cmp);

	if (p) {
		if (debug > 1)
			fprintf(stderr, "%s: %d\n", s, p->k_val);
		return (p->k_val);
	} else {
		if (debug > 1)
			fprintf(stderr, "string: %s\n", s);
		return (STRING);
	}
}

#define START_EXPAND	1
#define DONE_EXPAND	2

static int	expanding;

int
igetc(void)
{
	int	c;

	while (1) {
		if (file->ungetpos > 0)
			c = file->ungetbuf[--file->ungetpos];
		else
			c = getc(file->stream);

		if (c == START_EXPAND)
			expanding = 1;
		else if (c == DONE_EXPAND)
			expanding = 0;
		else
			break;
	}
	return (c);
}

int
lgetc(int quotec)
{
	int		c, next;

	if (quotec) {
		if ((c = igetc()) == EOF) {
			yyerror("reached end of file while parsing "
			    "quoted string");
			if (file == topfile || popfile() == EOF)
				return (EOF);
			return (quotec);
		}
		return (c);
	}

	while ((c = igetc()) == '\\') {
		next = igetc();
		if (next != '\n') {
			c = next;
			break;
		}
		yylval.lineno = file->lineno;
		file->lineno++;
	}

	while (c == EOF) {
		/*
		 * Fake EOL when hit EOF for the first time. This gets line
		 * count right if last line in included file is syntactically
		 * invalid and has no newline.
		 */
		if (file->eof_reached == 0) {
			file->eof_reached = 1;
			return ('\n');
		}
		while (c == EOF) {
			if (file == topfile || popfile() == EOF)
				return (EOF);
			c = igetc();
		}
	}
	return (c);
}

void
lungetc(int c)
{
	if (c == EOF)
		return;

	if (file->ungetpos >= file->ungetsize) {
		void *p = reallocarray(file->ungetbuf, file->ungetsize, 2);
		if (p == NULL)
			err(1, "lungetc");
		file->ungetbuf = p;
		file->ungetsize *= 2;
	}
	file->ungetbuf[file->ungetpos++] = c;
}

int
findeol(void)
{
	int	c;

	/* skip to either EOF or the first real EOL */
	while (1) {
		c = lgetc(0);
		if (c == '\n') {
			file->lineno++;
			break;
		}
		if (c == EOF)
			break;
	}
	return (ERROR);
}

int
yylex(void)
{
	char	 buf[8096];
	char	*p, *val;
	int	 quotec, next, c;
	int	 token;

top:
	p = buf;
	while ((c = lgetc(0)) == ' ' || c == '\t')
		; /* nothing */

	yylval.lineno = file->lineno;
	if (c == '#')
		while ((c = lgetc(0)) != '\n' && c != EOF)
			; /* nothing */
	if (c == '$' && !expanding) {
		while (1) {
			if ((c = lgetc(0)) == EOF)
				return (0);

			if (p + 1 >= buf + sizeof(buf) - 1) {
				yyerror("string too long");
				return (findeol());
			}
			if (isalnum(c) || c == '_') {
				*p++ = c;
				continue;
			}
			*p = '\0';
			lungetc(c);
			break;
		}
		val = symget(buf);
		if (val == NULL) {
			yyerror("macro '%s' not defined", buf);
			return (findeol());
		}
		p = val + strlen(val) - 1;
		lungetc(DONE_EXPAND);
		while (p >= val) {
			lungetc((unsigned char)*p);
			p--;
		}
		lungetc(START_EXPAND);
		goto top;
	}

	switch (c) {
	case '\'':
	case '"':
		quotec = c;
		while (1) {
			if ((c = lgetc(quotec)) == EOF)
				return (0);
			if (c == '\n') {
				file->lineno++;
				continue;
			} else if (c == '\\') {
				if ((next = lgetc(quotec)) == EOF)
					return (0);
				if (next == quotec || next == ' ' ||
				    next == '\t')
					c = next;
				else if (next == '\n') {
					file->lineno++;
					continue;
				} else
					lungetc(next);
			} else if (c == quotec) {
				*p = '\0';
				break;
			} else if (c == '\0') {
				yyerror("syntax error");
				return (findeol());
			}
			if (p + 1 >= buf + sizeof(buf) - 1) {
				yyerror("string too long");
				return (findeol());
			}
			*p++ = c;
		}
		yylval.v.string = strdup(buf);
		if (yylval.v.string == NULL)
			err(1, "%s", __func__);
		return (STRING);
	}

#define allowed_to_end_number(x) \
	(isspace(x) || x == ')' || x ==',' || x == '/' || x == '}' || x == '=')

	if (c == '-' || isdigit(c)) {
		do {
			*p++ = c;
			if ((size_t)(p-buf) >= sizeof(buf)) {
				yyerror("string too long");
				return (findeol());
			}
		} while ((c = lgetc(0)) != EOF && isdigit(c));
		lungetc(c);
		if (p == buf + 1 && buf[0] == '-')
			goto nodigits;
		if (c == EOF || allowed_to_end_number(c)) {
			const char *errstr = NULL;

			*p = '\0';
			yylval.v.number = strtonum(buf, LLONG_MIN,
			    LLONG_MAX, &errstr);
			if (errstr) {
				yyerror("\"%s\" invalid number: %s",
				    buf, errstr);
				return (findeol());
			}
			return (NUMBER);
		} else {
nodigits:
			while (p > buf + 1)
				lungetc((unsigned char)*--p);
			c = (unsigned char)*--p;
			if (c == '-')
				return (c);
		}
	}

#define allowed_in_string(x) \
	(isalnum(x) || (ispunct(x) && x != '(' && x != ')' && \
	x != '{' && x != '}' && x != '<' && x != '>' && \
	x != '!' && x != '=' && x != '/' && x != '#' && \
	x != ','))

	if (isalnum(c) || c == ':' || c == '_' || c == '*') {
		do {
			*p++ = c;
			if ((size_t)(p-buf) >= sizeof(buf)) {
				yyerror("string too long");
				return (findeol());
			}
		} while ((c = lgetc(0)) != EOF && (allowed_in_string(c)));
		lungetc(c);
		*p = '\0';
		if ((token = lookup(buf)) == STRING)
			if ((yylval.v.string = strdup(buf)) == NULL)
				err(1, "%s", __func__);
		return (token);
	}
	if (c == '\n') {
		yylval.lineno = file->lineno;
		file->lineno++;
	}
	if (c == EOF)
		return (0);
	return (c);
}

int
check_file_secrecy(int fd, const char *fname)
{
	struct stat	st;

	if (fstat(fd, &st)) {
		warn("cannot stat %s", fname);
		return (-1);
	}
	if (st.st_uid != 0 && st.st_uid != getuid()) {
		warnx("%s: owner not root or current user", fname);
		return (-1);
	}
	if (st.st_mode & (S_IWGRP | S_IXGRP | S_IRWXO)) {
		warnx("%s: group writable or world read/writable", fname);
		return (-1);
	}
	return (0);
}

struct file *
pushfile(const char *name, int secret)
{
	struct file	*nfile;

	if ((nfile = calloc(1, sizeof(struct file))) == NULL) {
		warn("%s", __func__);
		return (NULL);
	}
	if ((nfile->name = strdup(name)) == NULL) {
		warn("%s", __func__);
		free(nfile);
		return (NULL);
	}
	if (TAILQ_FIRST(&files) == NULL && strcmp(nfile->name, "-") == 0) {
		nfile->stream = stdin;
		free(nfile->name);
		if ((nfile->name = strdup("stdin")) == NULL) {
			warn("%s", __func__);
			free(nfile);
			return (NULL);
		}
	} else if ((nfile->stream = fopen(nfile->name, "r")) == NULL) {
		warn("%s: %s", __func__, nfile->name);
		free(nfile->name);
		free(nfile);
		return (NULL);
	} else if (secret &&
	    check_file_secrecy(fileno(nfile->stream), nfile->name)) {
		fclose(nfile->stream);
		free(nfile->name);
		free(nfile);
		return (NULL);
	}
	nfile->lineno = TAILQ_EMPTY(&files) ? 1 : 0;
	nfile->ungetsize = 16;
	nfile->ungetbuf = malloc(nfile->ungetsize);
	if (nfile->ungetbuf == NULL) {
		warn("%s", __func__);
		fclose(nfile->stream);
		free(nfile->name);
		free(nfile);
		return (NULL);
	}
	TAILQ_INSERT_TAIL(&files, nfile, entry);
	return (nfile);
}

int
popfile(void)
{
	struct file	*prev;

	if ((prev = TAILQ_PREV(file, files, entry)) != NULL)
		prev->errors += file->errors;

	TAILQ_REMOVE(&files, file, entry);
	fclose(file->stream);
	free(file->name);
	free(file->ungetbuf);
	free(file);
	file = prev;

	return (file ? 0 : EOF);
}

int
parse_config(const char *filename, struct iked *x_env)
{
	struct sym	*sym;
	int		 errors = 0;

	env = x_env;
	rules = 0;

	if ((file = pushfile(filename, 1)) == NULL)
		return (-1);
	topfile = file;

	free(ocsp_url);

	mobike = 1;
	enforcesingleikesa = stickyaddress = 0;
	cert_partial_chain = decouple = passive = 0;
	ocsp_tolerate = 0;
	ocsp_url = NULL;
	ocsp_maxage = -1;
	fragmentation = 0;
	dpd_interval = IKED_IKE_SA_ALIVE_TIMEOUT;
	decouple = passive = 0;
	ocsp_url = NULL;

	if (env->sc_opts & IKED_OPT_PASSIVE)
		passive = 1;

	yyparse();
	errors = file->errors;
	popfile();

	env->sc_passive = passive ? 1 : 0;
	env->sc_decoupled = decouple ? 1 : 0;
	env->sc_mobike = mobike;
	env->sc_enforcesingleikesa = enforcesingleikesa;
	env->sc_stickyaddress = stickyaddress;
	env->sc_frag = fragmentation;
	env->sc_alive_timeout = dpd_interval;
	env->sc_ocsp_url = ocsp_url;
	env->sc_ocsp_tolerate = ocsp_tolerate;
	env->sc_ocsp_maxage = ocsp_maxage;
	env->sc_cert_partial_chain = cert_partial_chain;
	env->sc_vendorid = vendorid;

	if (!rules)
		log_warnx("%s: no valid configuration rules found",
		    filename);
	else
		log_debug("%s: loaded %d configuration rules",
		    filename, rules);

	/* Free macros and check which have not been used. */
	while ((sym = TAILQ_FIRST(&symhead))) {
		if (!sym->used)
			log_debug("warning: macro '%s' not "
			    "used\n", sym->nam);
		free(sym->nam);
		free(sym->val);
		TAILQ_REMOVE(&symhead, sym, entry);
		free(sym);
	}

	iaw_free(iftab);
	iftab = NULL;

	return (errors ? -1 : 0);
}

int
symset(const char *nam, const char *val, int persist)
{
	struct sym	*sym;

	TAILQ_FOREACH(sym, &symhead, entry) {
		if (strcmp(nam, sym->nam) == 0)
			break;
	}

	if (sym != NULL) {
		if (sym->persist == 1)
			return (0);
		else {
			free(sym->nam);
			free(sym->val);
			TAILQ_REMOVE(&symhead, sym, entry);
			free(sym);
		}
	}
	if ((sym = calloc(1, sizeof(*sym))) == NULL)
		return (-1);

	sym->nam = strdup(nam);
	if (sym->nam == NULL) {
		free(sym);
		return (-1);
	}
	sym->val = strdup(val);
	if (sym->val == NULL) {
		free(sym->nam);
		free(sym);
		return (-1);
	}
	sym->used = 0;
	sym->persist = persist;
	TAILQ_INSERT_TAIL(&symhead, sym, entry);
	return (0);
}

int
cmdline_symset(char *s)
{
	char	*sym, *val;
	int	ret;

	if ((val = strrchr(s, '=')) == NULL)
		return (-1);

	sym = strndup(s, val - s);
	if (sym == NULL)
		err(1, "%s", __func__);
	ret = symset(sym, val + 1, 1);
	free(sym);

	return (ret);
}

char *
symget(const char *nam)
{
	struct sym	*sym;

	TAILQ_FOREACH(sym, &symhead, entry) {
		if (strcmp(nam, sym->nam) == 0) {
			sym->used = 1;
			return (sym->val);
		}
	}
	return (NULL);
}

uint8_t
x2i(unsigned char *s)
{
	char	ss[3];

	ss[0] = s[0];
	ss[1] = s[1];
	ss[2] = 0;

	if (!isxdigit(s[0]) || !isxdigit(s[1])) {
		yyerror("keys need to be specified in hex digits");
		return (-1);
	}
	return ((uint8_t)strtoul(ss, NULL, 16));
}

int
parsekey(unsigned char *hexkey, size_t len, struct iked_auth *auth)
{
	unsigned int	  i;

	bzero(auth, sizeof(*auth));
	if ((len / 2) > sizeof(auth->auth_data))
		return (-1);
	auth->auth_length = len / 2;

	for (i = 0; i < auth->auth_length; i++)
		auth->auth_data[i] = x2i(hexkey + 2 * i);

	return (0);
}

int
parsekeyfile(char *filename, struct iked_auth *auth)
{
	struct stat	 sb;
	int		 fd, ret;
	unsigned char	*hex;

	if ((fd = open(filename, O_RDONLY)) == -1)
		err(1, "open %s", filename);
	if (fstat(fd, &sb) == -1)
		err(1, "parsekeyfile: stat %s", filename);
	if ((sb.st_size > KEYSIZE_LIMIT) || (sb.st_size == 0))
		errx(1, "%s: key too %s", filename, sb.st_size ? "large" :
		    "small");
	if ((hex = calloc(sb.st_size, sizeof(unsigned char))) == NULL)
		err(1, "parsekeyfile: calloc");
	if (read(fd, hex, sb.st_size) < sb.st_size)
		err(1, "parsekeyfile: read");
	close(fd);
	ret = parsekey(hex, sb.st_size, auth);
	free(hex);
	return (ret);
}

int
get_id_type(char *string)
{
	struct in6_addr ia;

	if (string == NULL)
		return (IKEV2_ID_NONE);

	if (*string == '/')
		return (IKEV2_ID_ASN1_DN);
	else if (inet_pton(AF_INET, string, &ia) == 1)
		return (IKEV2_ID_IPV4);
	else if (inet_pton(AF_INET6, string, &ia) == 1)
		return (IKEV2_ID_IPV6);
	else if (strchr(string, '@'))
		return (IKEV2_ID_UFQDN);
	else
		return (IKEV2_ID_FQDN);
}

struct ipsec_addr_wrap *
host(const char *s)
{
	struct ipsec_addr_wrap	*ipa = NULL;
	int			 mask = -1;
	char			*p, *ps;
	const char		*errstr;

	if ((ps = strdup(s)) == NULL)
		err(1, "%s: strdup", __func__);

	if ((p = strchr(ps, '/')) != NULL) {
		mask = strtonum(p+1, 0, 128, &errstr);
		if (errstr) {
			fprintf(stderr, "netmask is %s: %s\n", errstr, p);
			goto error;
		}
		p[0] = '\0';
	}

	if ((ipa = host_if(ps, mask)) == NULL &&
	    (ipa = host_ip(ps, mask)) == NULL &&
	    (ipa = host_dns(ps, mask)) == NULL)
		fprintf(stderr, "no IP address found for %s\n", s);

error:
	free(ps);
	return (ipa);
}

struct ipsec_addr_wrap *
host_ip(const char *s, int mask)
{
	struct ipsec_addr_wrap	*ipa = NULL;
	struct addrinfo		 hints, *res;
	char			 hbuf[NI_MAXHOST];

	bzero(&hints, sizeof(struct addrinfo));
	hints.ai_family = AF_UNSPEC;
	hints.ai_socktype = SOCK_DGRAM; /*dummy*/
	hints.ai_flags = AI_NUMERICHOST;
	if (getaddrinfo(s, NULL, &hints, &res))
		return (NULL);
	if (res->ai_next)
		err(1, "%s: %s expanded to multiple item", __func__, s);

	ipa = calloc(1, sizeof(struct ipsec_addr_wrap));
	if (ipa == NULL)
		err(1, "%s", __func__);
	ipa->af = res->ai_family;
	copy_sockaddrtoipa(ipa, res->ai_addr);
	ipa->next = NULL;
	ipa->tail = ipa;

	set_ipmask(ipa, mask);
	if (getnameinfo(res->ai_addr, res->ai_addrlen,
	    hbuf, sizeof(hbuf), NULL, 0, NI_NUMERICHOST)) {
		errx(1, "could not get a numeric hostname");
	}

	if (mask > -1) {
		ipa->netaddress = 1;
		if (asprintf(&ipa->name, "%s/%d", hbuf, mask) == -1)
			err(1, "%s", __func__);
	} else {
		if ((ipa->name = strdup(hbuf)) == NULL)
			err(1, "%s", __func__);
	}

	freeaddrinfo(res);

	return (ipa);
}

struct ipsec_addr_wrap *
host_dns(const char *s, int mask)
{
	struct ipsec_addr_wrap	*ipa = NULL, *head = NULL;
	struct addrinfo		 hints, *res0, *res;
	int			 error;
	char			 hbuf[NI_MAXHOST];

	bzero(&hints, sizeof(struct addrinfo));
	hints.ai_family = PF_UNSPEC;
	hints.ai_socktype = SOCK_STREAM;
	hints.ai_flags = AI_ADDRCONFIG;
	error = getaddrinfo(s, NULL, &hints, &res0);
	if (error)
		return (NULL);

	for (res = res0; res; res = res->ai_next) {
		if (res->ai_family != AF_INET && res->ai_family != AF_INET6)
			continue;

		ipa = calloc(1, sizeof(struct ipsec_addr_wrap));
		if (ipa == NULL)
			err(1, "%s", __func__);
		copy_sockaddrtoipa(ipa, res->ai_addr);
		error = getnameinfo(res->ai_addr, res->ai_addrlen, hbuf,
		    sizeof(hbuf), NULL, 0, NI_NUMERICHOST);
		if (error)
			err(1, "host_dns: getnameinfo");
		ipa->name = strdup(hbuf);
		if (ipa->name == NULL)
			err(1, "%s", __func__);
		ipa->af = res->ai_family;
		ipa->next = NULL;
		ipa->tail = ipa;
		if (head == NULL)
			head = ipa;
		else {
			head->tail->next = ipa;
			head->tail = ipa;
		}

		/*
		 * XXX for now, no netmask support for IPv6.
		 * but since there's no way to specify address family, once you
		 * have IPv6 address on a host, you cannot use dns/netmask
		 * syntax.
		 */
		if (ipa->af == AF_INET)
			set_ipmask(ipa, mask == -1 ? 32 : mask);
		else
			if (mask != -1)
				err(1, "host_dns: cannot apply netmask "
				    "on non-IPv4 address");
	}
	freeaddrinfo(res0);

	return (head);
}

struct ipsec_addr_wrap *
host_if(const char *s, int mask)
{
	struct ipsec_addr_wrap *ipa = NULL;

	if (ifa_exists(s))
		ipa = ifa_lookup(s);

	return (ipa);
}

struct ipsec_addr_wrap *
host_any(void)
{
	struct ipsec_addr_wrap	*ipa;

	ipa = calloc(1, sizeof(struct ipsec_addr_wrap));
	if (ipa == NULL)
		err(1, "%s", __func__);
	ipa->af = AF_UNSPEC;
	ipa->netaddress = 1;
	ipa->tail = ipa;
	ipa->type = IPSEC_ADDR_ANY;
	return (ipa);
}

struct ipsec_addr_wrap *
host_dynamic(void)
{
	struct ipsec_addr_wrap	*ipa;

	ipa = calloc(1, sizeof(struct ipsec_addr_wrap));
	if (ipa == NULL)
		err(1, "%s", __func__);
	ipa->af = AF_UNSPEC;
	ipa->tail = ipa;
	ipa->type = IPSEC_ADDR_DYNAMIC;
	return (ipa);
}

void
ifa_load(void)
{
	struct ifaddrs		*ifap, *ifa;
	struct ipsec_addr_wrap	*n = NULL, *h = NULL;
	struct sockaddr_in	*sa_in;
	struct sockaddr_in6	*sa_in6;

	if (getifaddrs(&ifap) == -1)
		err(1, "ifa_load: getifaddrs");

	for (ifa = ifap; ifa; ifa = ifa->ifa_next) {
		if (ifa->ifa_addr == NULL ||
		    !(ifa->ifa_addr->sa_family == AF_INET ||
		    ifa->ifa_addr->sa_family == AF_INET6 ||
		    ifa->ifa_addr->sa_family == AF_LINK))
			continue;
		n = calloc(1, sizeof(struct ipsec_addr_wrap));
		if (n == NULL)
			err(1, "%s", __func__);
		n->af = ifa->ifa_addr->sa_family;
		if ((n->name = strdup(ifa->ifa_name)) == NULL)
			err(1, "%s", __func__);
		if (n->af == AF_INET) {
			sa_in = (struct sockaddr_in *)ifa->ifa_addr;
			memcpy(&n->address, sa_in, sizeof(*sa_in));
			sa_in = (struct sockaddr_in *)ifa->ifa_netmask;
			n->mask = mask2prefixlen((struct sockaddr *)sa_in);
		} else if (n->af == AF_INET6) {
			sa_in6 = (struct sockaddr_in6 *)ifa->ifa_addr;
			memcpy(&n->address, sa_in6, sizeof(*sa_in6));
			sa_in6 = (struct sockaddr_in6 *)ifa->ifa_netmask;
			n->mask = mask2prefixlen6((struct sockaddr *)sa_in6);
		}
		n->next = NULL;
		n->tail = n;
		if (h == NULL)
			h = n;
		else {
			h->tail->next = n;
			h->tail = n;
		}
	}

	iftab = h;
	freeifaddrs(ifap);
}

int
ifa_exists(const char *ifa_name)
{
	struct ipsec_addr_wrap	*n;
#ifdef __OpenBSD__
	struct ifgroupreq	 ifgr;
#endif
	int			 s;

	if (iftab == NULL)
		ifa_load();

	/* check wether this is a group */
	if ((s = socket(AF_INET, SOCK_DGRAM, 0)) == -1)
		err(1, "ifa_exists: socket");
#ifdef __OpenBSD__
	bzero(&ifgr, sizeof(ifgr));
	strlcpy(ifgr.ifgr_name, ifa_name, sizeof(ifgr.ifgr_name));
	if (ioctl(s, SIOCGIFGMEMB, (caddr_t)&ifgr) == 0) {
		close(s);
		return (1);
	}
#endif
	close(s);

	for (n = iftab; n; n = n->next) {
		if (n->af == AF_LINK && !strncmp(n->name, ifa_name,
		    IFNAMSIZ))
			return (1);
	}

	return (0);
}

#ifdef __OpenBSD__
struct ipsec_addr_wrap *
ifa_grouplookup(const char *ifa_name)
{
	struct ifg_req		*ifg;
	struct ifgroupreq	 ifgr;
	int			 s;
	size_t			 len;
	struct ipsec_addr_wrap	*n, *h = NULL, *hn;

	if ((s = socket(AF_INET, SOCK_DGRAM, 0)) == -1)
		err(1, "socket");
	bzero(&ifgr, sizeof(ifgr));
	strlcpy(ifgr.ifgr_name, ifa_name, sizeof(ifgr.ifgr_name));
	if (ioctl(s, SIOCGIFGMEMB, (caddr_t)&ifgr) == -1) {
		close(s);
		return (NULL);
	}

	len = ifgr.ifgr_len;
	if ((ifgr.ifgr_groups = calloc(1, len)) == NULL)
		err(1, "%s", __func__);
	if (ioctl(s, SIOCGIFGMEMB, (caddr_t)&ifgr) == -1)
		err(1, "ioctl");

	for (ifg = ifgr.ifgr_groups; ifg && len >= sizeof(struct ifg_req);
	    ifg++) {
		len -= sizeof(struct ifg_req);
		if ((n = ifa_lookup(ifg->ifgrq_member)) == NULL)
			continue;
		if (h == NULL)
			h = n;
		else {
			for (hn = h; hn->next != NULL; hn = hn->next)
				;	/* nothing */
			hn->next = n;
			n->tail = hn;
		}
	}
	free(ifgr.ifgr_groups);
	close(s);

	return (h);
}
#endif

struct ipsec_addr_wrap *
ifa_lookup(const char *ifa_name)
{
	struct ipsec_addr_wrap	*p = NULL, *h = NULL, *n = NULL;
	struct sockaddr_in6	*in6;
	uint8_t			*s6;

	if (iftab == NULL)
		ifa_load();

#ifdef __OpenBSD__
	if ((n = ifa_grouplookup(ifa_name)) != NULL)
		return (n);
#endif

	for (p = iftab; p; p = p->next) {
		if (p->af != AF_INET && p->af != AF_INET6)
			continue;
		if (strncmp(p->name, ifa_name, IFNAMSIZ))
			continue;
		n = calloc(1, sizeof(struct ipsec_addr_wrap));
		if (n == NULL)
			err(1, "%s", __func__);
		memcpy(n, p, sizeof(struct ipsec_addr_wrap));
		if ((n->name = strdup(p->name)) == NULL)
			err(1, "%s", __func__);
		switch (n->af) {
		case AF_INET:
			set_ipmask(n, 32);
			break;
		case AF_INET6:
			in6 = (struct sockaddr_in6 *)&n->address;
			s6 = (uint8_t *)&in6->sin6_addr.s6_addr;

			/* route/show.c and bgpd/util.c give KAME credit */
			if (IN6_IS_ADDR_LINKLOCAL(&in6->sin6_addr)) {
				uint16_t	 tmp16;

				/* for now we can not handle link local,
				 * therefore bail for now
				 */
				free(n->name);
				free(n);
				continue;

				memcpy(&tmp16, &s6[2], sizeof(tmp16));
				/* use this when we support link-local
				 * n->??.scopeid = ntohs(tmp16);
				 */
				s6[2] = 0;
				s6[3] = 0;
			}
			set_ipmask(n, 128);
			break;
		}

		n->next = NULL;
		n->tail = n;
		if (h == NULL)
			h = n;
		else {
			h->tail->next = n;
			h->tail = n;
		}
	}

	return (h);
}

void
set_ipmask(struct ipsec_addr_wrap *address, int b)
{
	if (b == -1)
		address->mask = address->af == AF_INET ? 32 : 128;
	else
		address->mask = b;
}

const struct ipsec_xf *
parse_xf(const char *name, unsigned int length, const struct ipsec_xf xfs[])
{
	int		i;

	for (i = 0; xfs[i].name != NULL; i++) {
		if (strncmp(name, xfs[i].name, strlen(name)))
			continue;
		if (length == 0 || length == xfs[i].length)
			return &xfs[i];
	}
	return (NULL);
}

int
encxf_noauth(unsigned int id)
{
	int i;

	for (i = 0; ikeencxfs[i].name != NULL; i++)
		if (ikeencxfs[i].id == id)
			return ikeencxfs[i].noauth;
	return (0);
}

size_t
keylength_xf(unsigned int saproto, unsigned int type, unsigned int id)
{
	int			 i;
	const struct ipsec_xf	*xfs;

	switch (type) {
	case IKEV2_XFORMTYPE_ENCR:
		if (saproto == IKEV2_SAPROTO_IKE)
			xfs = ikeencxfs;
		else
			xfs = ipsecencxfs;
		break;
	case IKEV2_XFORMTYPE_INTEGR:
		xfs = authxfs;
		break;
	default:
		return (0);
	}

	for (i = 0; xfs[i].name != NULL; i++) {
		if (xfs[i].id == id)
			return (xfs[i].length * 8);
	}
	return (0);
}

size_t
noncelength_xf(unsigned int type, unsigned int id)
{
	const struct ipsec_xf	*xfs = ipsecencxfs;
	int			 i;

	if (type != IKEV2_XFORMTYPE_ENCR)
		return (0);

	for (i = 0; xfs[i].name != NULL; i++)
		if (xfs[i].id == id)
			return (xfs[i].nonce * 8);
	return (0);
}

void
copy_transforms(unsigned int type,
    const struct ipsec_xf **xfs, unsigned int nxfs,
    struct iked_transform **dst, unsigned int *ndst,
    struct iked_transform *src, size_t nsrc)
{
	unsigned int		 i;
	struct iked_transform	*a, *b;
	const struct ipsec_xf	*xf;

	if (nxfs) {
		for (i = 0; i < nxfs; i++) {
			xf = xfs[i];
			*dst = recallocarray(*dst, *ndst,
			    *ndst + 1, sizeof(struct iked_transform));
			if (*dst == NULL)
				err(1, "%s", __func__);
			b = *dst + (*ndst)++;

			b->xform_type = type;
			b->xform_id = xf->id;
			b->xform_keylength = xf->length * 8;
			b->xform_length = xf->keylength * 8;
		}
		return;
	}

	for (i = 0; i < nsrc; i++) {
		a = src + i;
		if (a->xform_type != type)
			continue;
		*dst = recallocarray(*dst, *ndst,
		    *ndst + 1, sizeof(struct iked_transform));
		if (*dst == NULL)
			err(1, "%s", __func__);
		b = *dst + (*ndst)++;
		memcpy(b, a, sizeof(*b));
	}
}

int
create_ike(char *name, int af, struct ipsec_addr_wrap *ipproto,
    int rdomain, struct ipsec_hosts *hosts,
    struct ipsec_hosts *peers, struct ipsec_mode *ike_sa,
    struct ipsec_mode *ipsec_sa, uint8_t saproto,
    uint8_t flags, char *srcid, char *dstid,
    uint32_t ikelifetime, struct iked_lifetime *lt,
    struct iked_auth *authtype, struct ipsec_filters *filter,
    struct ipsec_addr_wrap *ikecfg, char *iface)
{
	char			 idstr[IKED_ID_SIZE];
	struct ipsec_addr_wrap	*ipa, *ipb, *ipp;
	struct iked_auth	*ikeauth;
	struct iked_policy	 pol;
	struct iked_proposal	*p, *ptmp;
	struct iked_transform	*xf;
	unsigned int		 i, j, xfi, noauth, auth;
	unsigned int		 ikepropid = 1, ipsecpropid = 1;
	struct iked_flow	*flow, *ftmp;
	static unsigned int	 policy_id = 0;
	struct iked_cfg		*cfg;
	int			 ret = -1;

	bzero(&pol, sizeof(pol));
	bzero(idstr, sizeof(idstr));

	pol.pol_id = ++policy_id;
	pol.pol_certreqtype = env->sc_certreqtype;
	pol.pol_af = af;
	pol.pol_saproto = saproto;
	for (i = 0, ipp = ipproto; ipp; ipp = ipp->next, i++) {
		if (i >= IKED_IPPROTO_MAX) {
			yyerror("too many protocols");
			return (-1);
		}
		pol.pol_ipproto[i] = ipp->type;
		pol.pol_nipproto++;
	}

	pol.pol_flags = flags;
	pol.pol_rdomain = rdomain;
	memcpy(&pol.pol_auth, authtype, sizeof(struct iked_auth));
	explicit_bzero(authtype, sizeof(*authtype));

	if (name != NULL) {
		if (strlcpy(pol.pol_name, name,
		    sizeof(pol.pol_name)) >= sizeof(pol.pol_name)) {
			yyerror("name too long");
			return (-1);
		}
	} else {
		snprintf(pol.pol_name, sizeof(pol.pol_name),
		    "policy%d", policy_id);
	}

	if (iface != NULL) {
		pol.pol_iface = if_nametoindex(iface);
		if (pol.pol_iface == 0) {
			yyerror("invalid iface");
			return (-1);
		}
	}

	if (srcid) {
		pol.pol_localid.id_type = get_id_type(srcid);
		pol.pol_localid.id_length = strlen(srcid);
		if (strlcpy((char *)pol.pol_localid.id_data,
		    srcid, IKED_ID_SIZE) >= IKED_ID_SIZE) {
			yyerror("srcid too long");
			return (-1);
		}
	}
	if (dstid) {
		pol.pol_peerid.id_type = get_id_type(dstid);
		pol.pol_peerid.id_length = strlen(dstid);
		if (strlcpy((char *)pol.pol_peerid.id_data,
		    dstid, IKED_ID_SIZE) >= IKED_ID_SIZE) {
			yyerror("dstid too long");
			return (-1);
		}
	}

	if (filter != NULL) {
		if (filter->tag)
			strlcpy(pol.pol_tag, filter->tag, sizeof(pol.pol_tag));
		pol.pol_tap = filter->tap;
	}

	if (peers == NULL) {
		if (pol.pol_flags & IKED_POLICY_ACTIVE) {
			yyerror("active mode requires peer specification");
			return (-1);
		}
		pol.pol_flags |= IKED_POLICY_DEFAULT|IKED_POLICY_SKIP;
	}

	if (peers && peers->src && peers->dst &&
	    (peers->src->af != AF_UNSPEC) && (peers->dst->af != AF_UNSPEC) &&
	    (peers->src->af != peers->dst->af))
		fatalx("create_ike: peer address family mismatch");

	if (peers && (pol.pol_af != AF_UNSPEC) &&
	    ((peers->src && (peers->src->af != AF_UNSPEC) &&
	    (peers->src->af != pol.pol_af)) ||
	    (peers->dst && (peers->dst->af != AF_UNSPEC) &&
	    (peers->dst->af != pol.pol_af))))
		fatalx("create_ike: policy address family mismatch");

	ipa = ipb = NULL;
	if (peers) {
		if (peers->src)
			ipa = peers->src;
		if (peers->dst)
			ipb = peers->dst;
		if (ipa == NULL && ipb == NULL) {
			if (hosts->src && hosts->src->next == NULL)
				ipa = hosts->src;
			if (hosts->dst && hosts->dst->next == NULL)
				ipb = hosts->dst;
		}
	}
	if (ipa == NULL && ipb == NULL) {
		yyerror("could not get local/peer specification");
		return (-1);
	}
	if (pol.pol_flags & IKED_POLICY_ACTIVE) {
		if (ipb == NULL || ipb->netaddress ||
		    (ipa != NULL && ipa->netaddress)) {
			yyerror("active mode requires local/peer address");
			return (-1);
		}
	}
	if (ipa) {
		memcpy(&pol.pol_local.addr, &ipa->address,
		    sizeof(ipa->address));
		pol.pol_local.addr_af = ipa->af;
		pol.pol_local.addr_mask = ipa->mask;
		pol.pol_local.addr_net = ipa->netaddress;
		if (pol.pol_af == AF_UNSPEC)
			pol.pol_af = ipa->af;
	}
	if (ipb) {
		memcpy(&pol.pol_peer.addr, &ipb->address,
		    sizeof(ipb->address));
		pol.pol_peer.addr_af = ipb->af;
		pol.pol_peer.addr_mask = ipb->mask;
		pol.pol_peer.addr_net = ipb->netaddress;
		if (pol.pol_af == AF_UNSPEC)
			pol.pol_af = ipb->af;
	}

	if (ikelifetime)
		pol.pol_rekey = ikelifetime;

	if (lt)
		pol.pol_lifetime = *lt;
	else
		pol.pol_lifetime = deflifetime;

	TAILQ_INIT(&pol.pol_proposals);
	RB_INIT(&pol.pol_flows);

	if (ike_sa == NULL || ike_sa->nxfs == 0) {
		/* AES-GCM proposal */
		if ((p = calloc(1, sizeof(*p))) == NULL)
			err(1, "%s", __func__);
		p->prop_id = ikepropid++;
		p->prop_protoid = IKEV2_SAPROTO_IKE;
		p->prop_nxforms = ikev2_default_nike_transforms_noauth;
		p->prop_xforms = ikev2_default_ike_transforms_noauth;
		TAILQ_INSERT_TAIL(&pol.pol_proposals, p, prop_entry);
		pol.pol_nproposals++;

		/* Non GCM proposal */
		if ((p = calloc(1, sizeof(*p))) == NULL)
			err(1, "%s", __func__);
		p->prop_id = ikepropid++;
		p->prop_protoid = IKEV2_SAPROTO_IKE;
		p->prop_nxforms = ikev2_default_nike_transforms;
		p->prop_xforms = ikev2_default_ike_transforms;
		TAILQ_INSERT_TAIL(&pol.pol_proposals, p, prop_entry);
		pol.pol_nproposals++;
	} else {
		for (i = 0; i < ike_sa->nxfs; i++) {
			noauth = auth = 0;
			for (j = 0; j < ike_sa->xfs[i]->nencxf; j++) {
				if (ike_sa->xfs[i]->encxf[j]->noauth)
					noauth++;
				else
					auth++;
			}
			for (j = 0; j < ike_sa->xfs[i]->ngroupxf; j++) {
				if (ike_sa->xfs[i]->groupxf[j]->id
				    == IKEV2_XFORMDH_NONE) {
					yyerror("IKE group can not be \"none\".");
					goto done;
				}
			}
			if (ike_sa->xfs[i]->nauthxf)
				auth++;

			if (ike_sa->xfs[i]->nesnxf) {
				yyerror("cannot use ESN with ikesa.");
				goto done;
			}
			if (noauth && noauth != ike_sa->xfs[i]->nencxf) {
				yyerror("cannot mix encryption transforms with "
				    "implicit and non-implicit authentication");
				goto done;
			}
			if (noauth && ike_sa->xfs[i]->nauthxf) {
				yyerror("authentication is implicit for given "
				    "encryption transforms");
				goto done;
			}

			if (!auth) {
				if ((p = calloc(1, sizeof(*p))) == NULL)
					err(1, "%s", __func__);

				xf = NULL;
				xfi = 0;
				copy_transforms(IKEV2_XFORMTYPE_ENCR,
				    ike_sa->xfs[i]->encxf,
				    ike_sa->xfs[i]->nencxf, &xf, &xfi,
				    ikev2_default_ike_transforms_noauth,
				    ikev2_default_nike_transforms_noauth);
				copy_transforms(IKEV2_XFORMTYPE_DH,
				    ike_sa->xfs[i]->groupxf,
				    ike_sa->xfs[i]->ngroupxf, &xf, &xfi,
				    ikev2_default_ike_transforms_noauth,
				    ikev2_default_nike_transforms_noauth);
				copy_transforms(IKEV2_XFORMTYPE_PRF,
				    ike_sa->xfs[i]->prfxf,
				    ike_sa->xfs[i]->nprfxf, &xf, &xfi,
				    ikev2_default_ike_transforms_noauth,
				    ikev2_default_nike_transforms_noauth);

				p->prop_id = ikepropid++;
				p->prop_protoid = IKEV2_SAPROTO_IKE;
				p->prop_xforms = xf;
				p->prop_nxforms = xfi;
				TAILQ_INSERT_TAIL(&pol.pol_proposals, p, prop_entry);
				pol.pol_nproposals++;
			}
			if (!noauth) {
				if ((p = calloc(1, sizeof(*p))) == NULL)
					err(1, "%s", __func__);

				xf = NULL;
				xfi = 0;
				copy_transforms(IKEV2_XFORMTYPE_INTEGR,
				    ike_sa->xfs[i]->authxf,
				    ike_sa->xfs[i]->nauthxf, &xf, &xfi,
				    ikev2_default_ike_transforms,
				    ikev2_default_nike_transforms);
				copy_transforms(IKEV2_XFORMTYPE_ENCR,
				    ike_sa->xfs[i]->encxf,
				    ike_sa->xfs[i]->nencxf, &xf, &xfi,
				    ikev2_default_ike_transforms,
				    ikev2_default_nike_transforms);
				copy_transforms(IKEV2_XFORMTYPE_DH,
				    ike_sa->xfs[i]->groupxf,
				    ike_sa->xfs[i]->ngroupxf, &xf, &xfi,
				    ikev2_default_ike_transforms,
				    ikev2_default_nike_transforms);
				copy_transforms(IKEV2_XFORMTYPE_PRF,
				    ike_sa->xfs[i]->prfxf,
				    ike_sa->xfs[i]->nprfxf, &xf, &xfi,
				    ikev2_default_ike_transforms,
				    ikev2_default_nike_transforms);

				p->prop_id = ikepropid++;
				p->prop_protoid = IKEV2_SAPROTO_IKE;
				p->prop_xforms = xf;
				p->prop_nxforms = xfi;
				TAILQ_INSERT_TAIL(&pol.pol_proposals, p, prop_entry);
				pol.pol_nproposals++;
			}
		}
	}

	if (ipsec_sa == NULL || ipsec_sa->nxfs == 0) {
	/* XXX: Linux pfkey does not support AES-GCM */
#if !defined(HAVE_LINUX_PFKEY_H)
		if ((p = calloc(1, sizeof(*p))) == NULL)
			err(1, "%s", __func__);
		p->prop_id = ipsecpropid++;
		p->prop_protoid = saproto;
		p->prop_nxforms = ikev2_default_nesp_transforms_noauth;
		p->prop_xforms = ikev2_default_esp_transforms_noauth;
		TAILQ_INSERT_TAIL(&pol.pol_proposals, p, prop_entry);
		pol.pol_nproposals++;
#endif

		if ((p = calloc(1, sizeof(*p))) == NULL)
			err(1, "%s", __func__);
		p->prop_id = ipsecpropid++;
		p->prop_protoid = saproto;
		p->prop_nxforms = ikev2_default_nesp_transforms;
		p->prop_xforms = ikev2_default_esp_transforms;
		TAILQ_INSERT_TAIL(&pol.pol_proposals, p, prop_entry);
		pol.pol_nproposals++;
	} else {
		for (i = 0; i < ipsec_sa->nxfs; i++) {
			noauth = auth = 0;
			for (j = 0; j < ipsec_sa->xfs[i]->nencxf; j++) {
				if (ipsec_sa->xfs[i]->encxf[j]->noauth)
					noauth++;
				else
					auth++;
			}
			if (ipsec_sa->xfs[i]->nauthxf)
				auth++;

			if (noauth && noauth != ipsec_sa->xfs[i]->nencxf) {
				yyerror("cannot mix encryption transforms with "
				    "implicit and non-implicit authentication");
				goto done;
			}
			if (noauth && ipsec_sa->xfs[i]->nauthxf) {
				yyerror("authentication is implicit for given "
				    "encryption transforms");
				goto done;
			}

			if (!auth) {
#if !defined(HAVE_LINUX_PFKEY_H)
				if ((p = calloc(1, sizeof(*p))) == NULL)
					err(1, "%s", __func__);

				xf = NULL;
				xfi = 0;
				copy_transforms(IKEV2_XFORMTYPE_ENCR,
				    ipsec_sa->xfs[i]->encxf,
				    ipsec_sa->xfs[i]->nencxf, &xf, &xfi,
				    ikev2_default_esp_transforms_noauth,
				    ikev2_default_nesp_transforms_noauth);
				copy_transforms(IKEV2_XFORMTYPE_DH,
				    ipsec_sa->xfs[i]->groupxf,
				    ipsec_sa->xfs[i]->ngroupxf, &xf, &xfi,
				    ikev2_default_esp_transforms_noauth,
				    ikev2_default_nesp_transforms_noauth);
				copy_transforms(IKEV2_XFORMTYPE_ESN,
				    ipsec_sa->xfs[i]->esnxf,
				    ipsec_sa->xfs[i]->nesnxf, &xf, &xfi,
				    ikev2_default_esp_transforms_noauth,
				    ikev2_default_nesp_transforms_noauth);

				p->prop_id = ipsecpropid++;
				p->prop_protoid = saproto;
				p->prop_xforms = xf;
				p->prop_nxforms = xfi;
				TAILQ_INSERT_TAIL(&pol.pol_proposals, p, prop_entry);
				pol.pol_nproposals++;
#endif
			}
			if (!noauth) {
				if ((p = calloc(1, sizeof(*p))) == NULL)
					err(1, "%s", __func__);

				xf = NULL;
				xfi = 0;
				copy_transforms(IKEV2_XFORMTYPE_INTEGR,
				    ipsec_sa->xfs[i]->authxf,
				    ipsec_sa->xfs[i]->nauthxf, &xf, &xfi,
				    ikev2_default_esp_transforms,
				    ikev2_default_nesp_transforms);
				copy_transforms(IKEV2_XFORMTYPE_ENCR,
				    ipsec_sa->xfs[i]->encxf,
				    ipsec_sa->xfs[i]->nencxf, &xf, &xfi,
				    ikev2_default_esp_transforms,
				    ikev2_default_nesp_transforms);
				copy_transforms(IKEV2_XFORMTYPE_DH,
				    ipsec_sa->xfs[i]->groupxf,
				    ipsec_sa->xfs[i]->ngroupxf, &xf, &xfi,
				    ikev2_default_esp_transforms,
				    ikev2_default_nesp_transforms);
				copy_transforms(IKEV2_XFORMTYPE_ESN,
				    ipsec_sa->xfs[i]->esnxf,
				    ipsec_sa->xfs[i]->nesnxf, &xf, &xfi,
				    ikev2_default_esp_transforms,
				    ikev2_default_nesp_transforms);

				p->prop_id = ipsecpropid++;
				p->prop_protoid = saproto;
				p->prop_xforms = xf;
				p->prop_nxforms = xfi;
				TAILQ_INSERT_TAIL(&pol.pol_proposals, p, prop_entry);
				pol.pol_nproposals++;
			}
		}
	}

	for (ipa = hosts->src, ipb = hosts->dst; ipa && ipb;
	    ipa = ipa->next, ipb = ipb->next) {
		for (j = 0; j < pol.pol_nipproto; j++)
			if (expand_flows(&pol, pol.pol_ipproto[j], ipa, ipb))
				fatalx("create_ike: invalid flow");
		if (pol.pol_nipproto == 0)
			if (expand_flows(&pol, 0, ipa, ipb))
				fatalx("create_ike: invalid flow");
	}

	for (j = 0, ipa = ikecfg; ipa; ipa = ipa->next, j++) {
		if (j >= IKED_CFG_MAX)
			break;
		cfg = &pol.pol_cfg[j];
		pol.pol_ncfg++;

		cfg->cfg_action = ipa->action;
		cfg->cfg_type = ipa->type;
		memcpy(&cfg->cfg.address.addr, &ipa->address,
		    sizeof(ipa->address));
		cfg->cfg.address.addr_mask = ipa->mask;
		cfg->cfg.address.addr_net = ipa->netaddress;
		cfg->cfg.address.addr_af = ipa->af;
	}

	if (dstid)
		strlcpy(idstr, dstid, sizeof(idstr));
	else if (!pol.pol_peer.addr_net)
		print_host((struct sockaddr *)&pol.pol_peer.addr, idstr,
		    sizeof(idstr));

	ikeauth = &pol.pol_auth;
	switch (ikeauth->auth_method) {
	case IKEV2_AUTH_RSA_SIG:
		pol.pol_certreqtype = IKEV2_CERT_RSA_KEY;
		break;
	case IKEV2_AUTH_ECDSA_256:
	case IKEV2_AUTH_ECDSA_384:
	case IKEV2_AUTH_ECDSA_521:
		pol.pol_certreqtype = IKEV2_CERT_ECDSA;
		break;
	default:
		pol.pol_certreqtype = IKEV2_CERT_NONE;
		break;
	}

	log_debug("%s: using %s for peer %s", __func__,
	    print_xf(ikeauth->auth_method, 0, methodxfs), idstr);

	config_setpolicy(env, &pol, PROC_IKEV2);
	config_setflow(env, &pol, PROC_IKEV2);

	rules++;
	ret = 0;

done:
	if (ike_sa) {
		for (i = 0; i < ike_sa->nxfs; i++) {
			free(ike_sa->xfs[i]->authxf);
			free(ike_sa->xfs[i]->encxf);
			free(ike_sa->xfs[i]->groupxf);
			free(ike_sa->xfs[i]->prfxf);
			free(ike_sa->xfs[i]);
		}
		free(ike_sa->xfs);
		free(ike_sa);
	}
	if (ipsec_sa) {
		for (i = 0; i < ipsec_sa->nxfs; i++) {
			free(ipsec_sa->xfs[i]->authxf);
			free(ipsec_sa->xfs[i]->encxf);
			free(ipsec_sa->xfs[i]->groupxf);
			free(ipsec_sa->xfs[i]->prfxf);
			free(ipsec_sa->xfs[i]->esnxf);
			free(ipsec_sa->xfs[i]);
		}
		free(ipsec_sa->xfs);
		free(ipsec_sa);
	}
	TAILQ_FOREACH_SAFE(p, &pol.pol_proposals, prop_entry, ptmp) {
		if (p->prop_xforms != ikev2_default_ike_transforms &&
		    p->prop_xforms != ikev2_default_ike_transforms_noauth &&
		    p->prop_xforms != ikev2_default_esp_transforms &&
		    p->prop_xforms != ikev2_default_esp_transforms_noauth)
			free(p->prop_xforms);
		free(p);
	}
	if (peers != NULL) {
		iaw_free(peers->src);
		iaw_free(peers->dst);
		/* peers is static, cannot be freed */
	}
	if (hosts != NULL) {
		iaw_free(hosts->src);
		iaw_free(hosts->dst);
		free(hosts);
	}
	iaw_free(ikecfg);
	iaw_free(ipproto);
	RB_FOREACH_SAFE(flow, iked_flows, &pol.pol_flows, ftmp) {
		RB_REMOVE(iked_flows, &pol.pol_flows, flow);
		free(flow);
	}
	free(name);
	free(srcid);
	free(dstid);
	return (ret);
}

static int
create_flow(struct iked_policy *pol, int proto, struct ipsec_addr_wrap *ipa,
    struct ipsec_addr_wrap *ipb)
{
	struct iked_flow	*flow;
	struct ipsec_addr_wrap	*ippn;

	if (ipa->af != ipb->af) {
		yyerror("cannot mix different address families.");
		return (-1);
	}

	if ((flow = calloc(1, sizeof(struct iked_flow))) == NULL)
		fatalx("%s: failed to alloc flow.", __func__);

	memcpy(&flow->flow_src.addr, &ipa->address,
	    sizeof(ipa->address));
	flow->flow_src.addr_af = ipa->af;
	flow->flow_src.addr_mask = ipa->mask;
	flow->flow_src.addr_net = ipa->netaddress;
	flow->flow_src.addr_port = ipa->port;

	memcpy(&flow->flow_dst.addr, &ipb->address,
	    sizeof(ipb->address));
	flow->flow_dst.addr_af = ipb->af;
	flow->flow_dst.addr_mask = ipb->mask;
	flow->flow_dst.addr_net = ipb->netaddress;
	flow->flow_dst.addr_port = ipb->port;

	ippn = ipa->srcnat;
	if (ippn) {
		memcpy(&flow->flow_prenat.addr, &ippn->address,
		    sizeof(ippn->address));
		flow->flow_prenat.addr_af = ippn->af;
		flow->flow_prenat.addr_mask = ippn->mask;
		flow->flow_prenat.addr_net = ippn->netaddress;
	} else {
		flow->flow_prenat.addr_af = 0;
	}

	flow->flow_dir = IPSP_DIRECTION_OUT;
	flow->flow_ipproto = proto;
	flow->flow_saproto = pol->pol_saproto;
	flow->flow_rdomain = pol->pol_rdomain;
	flow->flow_transport = pol->pol_flags & IKED_POLICY_TRANSPORT;

	if (RB_INSERT(iked_flows, &pol->pol_flows, flow) == NULL)
		pol->pol_nflows++;
	else {
		warnx("create_ike: duplicate flow");
		free(flow);
	}

	return (0);
}

static int
expand_flows(struct iked_policy *pol, int proto, struct ipsec_addr_wrap *src,
    struct ipsec_addr_wrap *dst)
{
	struct ipsec_addr_wrap	*ipa = NULL, *ipb = NULL;
	int			 ret = -1;
	int			 srcaf, dstaf;

	srcaf = src->af;
	dstaf = dst->af;

	if (src->af == AF_UNSPEC &&
	    dst->af == AF_UNSPEC) {
		/* Need both IPv4 and IPv6 flows */
		src->af = dst->af = AF_INET;
		ipa = expand_keyword(src);
		ipb = expand_keyword(dst);
		if (!ipa || !ipb)
			goto done;
		if (create_flow(pol, proto, ipa, ipb))
			goto done;

		iaw_free(ipa);
		iaw_free(ipb);
		src->af = dst->af = AF_INET6;
		ipa = expand_keyword(src);
		ipb = expand_keyword(dst);
		if (!ipa || !ipb)
			goto done;
		if (create_flow(pol, proto, ipa, ipb))
			goto done;
	} else if (src->af == AF_UNSPEC) {
		src->af = dst->af;
		ipa = expand_keyword(src);
		if (!ipa)
			goto done;
		if (create_flow(pol, proto, ipa, dst))
			goto done;
	} else if (dst->af == AF_UNSPEC) {
		dst->af = src->af;
		ipa = expand_keyword(dst);
		if (!ipa)
			goto done;
		if (create_flow(pol, proto, src, ipa))
			goto done;
	} else if (create_flow(pol, proto, src, dst))
		goto done;
	ret = 0;
 done:
	src->af = srcaf;
	dst->af = dstaf;
	iaw_free(ipa);
	iaw_free(ipb);
	return (ret);
}

static struct ipsec_addr_wrap *
expand_keyword(struct ipsec_addr_wrap *ip)
{
	switch(ip->af) {
	case AF_INET:
		switch(ip->type) {
		case IPSEC_ADDR_ANY:
			return (host("0.0.0.0/0"));
		case IPSEC_ADDR_DYNAMIC:
			return (host("0.0.0.0"));
		}
		break;
	case AF_INET6:
		switch(ip->type) {
		case IPSEC_ADDR_ANY:
			return (host("::/0"));
		case IPSEC_ADDR_DYNAMIC:
			return (host("::"));
		}
	}
	return (NULL);
}

int
create_user(const char *user, const char *pass)
{
	struct iked_user	 usr;

	bzero(&usr, sizeof(usr));

	if (*user == '\0' || (strlcpy(usr.usr_name, user,
	    sizeof(usr.usr_name)) >= sizeof(usr.usr_name))) {
		yyerror("invalid user name");
		return (-1);
	}
	if (*pass == '\0' || (strlcpy(usr.usr_pass, pass,
	    sizeof(usr.usr_pass)) >= sizeof(usr.usr_pass))) {
		yyerror("invalid password");
		explicit_bzero(&usr, sizeof usr);	/* zap partial password */
		return (-1);
	}

	config_setuser(env, &usr, PROC_IKEV2);

	rules++;

	explicit_bzero(&usr, sizeof usr);
	return (0);
}

void
iaw_free(struct ipsec_addr_wrap *head)
{
	struct ipsec_addr_wrap *n, *cur;

	if (head == NULL)
		return;

	for (n = head; n != NULL; ) {
		cur = n;
		n = n->next;
		if (cur->srcnat != NULL) {
			free(cur->srcnat->name);
			free(cur->srcnat);
		}
		free(cur->name);
		free(cur);
	}
}
#line 3157 "parse.c"

/* For use in generated program */
#define yydepth (int)(yystack.s_mark - yystack.s_base)
#if YYBTYACC
#define yytrial (yyps->save)
#endif /* YYBTYACC */

#if YYDEBUG
#include <stdio.h>	/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    YYINT *newss;
    YYSTYPE *newvs;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE *newps;
#endif

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return YYENOMEM;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = (int) (data->s_mark - data->s_base);
    newss = (YYINT *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return YYENOMEM;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return YYENOMEM;

    data->l_base = newvs;
    data->l_mark = newvs + i;

#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    newps = (YYLTYPE *)realloc(data->p_base, newsize * sizeof(*newps));
    if (newps == 0)
        return YYENOMEM;

    data->p_base = newps;
    data->p_mark = newps + i;
#endif

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;

#if YYDEBUG
    if (yydebug)
        fprintf(stderr, "%sdebug: stack size increased to %d\n", YYPREFIX, newsize);
#endif
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    free(data->p_base);
#endif
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif /* YYPURE || defined(YY_NO_LEAKS) */
#if YYBTYACC

static YYParseState *
yyNewState(unsigned size)
{
    YYParseState *p = (YYParseState *) malloc(sizeof(YYParseState));
    if (p == NULL) return NULL;

    p->yystack.stacksize = size;
    if (size == 0)
    {
        p->yystack.s_base = NULL;
        p->yystack.l_base = NULL;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        p->yystack.p_base = NULL;
#endif
        return p;
    }
    p->yystack.s_base    = (YYINT *) malloc(size * sizeof(YYINT));
    if (p->yystack.s_base == NULL) return NULL;
    p->yystack.l_base    = (YYSTYPE *) malloc(size * sizeof(YYSTYPE));
    if (p->yystack.l_base == NULL) return NULL;
    memset(p->yystack.l_base, 0, size * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    p->yystack.p_base    = (YYLTYPE *) malloc(size * sizeof(YYLTYPE));
    if (p->yystack.p_base == NULL) return NULL;
    memset(p->yystack.p_base, 0, size * sizeof(YYLTYPE));
#endif

    return p;
}

static void
yyFreeState(YYParseState *p)
{
    yyfreestack(&p->yystack);
    free(p);
}
#endif /* YYBTYACC */

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab
#if YYBTYACC
#define YYVALID        do { if (yyps->save)            goto yyvalid; } while(0)
#define YYVALID_NESTED do { if (yyps->save && \
                                yyps->save->save == 0) goto yyvalid; } while(0)
#endif /* YYBTYACC */

int
YYPARSE_DECL()
{
    int yym, yyn, yystate, yyresult;
#if YYBTYACC
    int yynewerrflag;
    YYParseState *yyerrctx = NULL;
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    YYLTYPE  yyerror_loc_range[3]; /* position of error start/end (0 unused) */
#endif
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
    if (yydebug)
        fprintf(stderr, "%sdebug[<# of symbols on state stack>]\n", YYPREFIX);
#endif
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    memset(yyerror_loc_range, 0, sizeof(yyerror_loc_range));
#endif

#if YYBTYACC
    yyps = yyNewState(0); if (yyps == 0) goto yyenomem;
    yyps->save = 0;
#endif /* YYBTYACC */
    yym = 0;
    /* yyn is set below */
    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark = yystack.p_base;
#endif
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
#if YYBTYACC
        do {
        if (yylvp < yylve)
        {
            /* we're currently re-reading tokens */
            yylval = *yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylloc = *yylpp++;
#endif
            yychar = *yylexp++;
            break;
        }
        if (yyps->save)
        {
            /* in trial mode; save scanner results for future parse attempts */
            if (yylvp == yylvlim)
            {   /* Enlarge lexical value queue */
                size_t p = (size_t) (yylvp - yylvals);
                size_t s = (size_t) (yylvlim - yylvals);

                s += YYLVQUEUEGROWTH;
                if ((yylexemes = (YYINT *)realloc(yylexemes, s * sizeof(YYINT))) == NULL) goto yyenomem;
                if ((yylvals   = (YYSTYPE *)realloc(yylvals, s * sizeof(YYSTYPE))) == NULL) goto yyenomem;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                if ((yylpsns   = (YYLTYPE *)realloc(yylpsns, s * sizeof(YYLTYPE))) == NULL) goto yyenomem;
#endif
                yylvp   = yylve = yylvals + p;
                yylvlim = yylvals + s;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp   = yylpe = yylpsns + p;
                yylplim = yylpsns + s;
#endif
                yylexp  = yylexemes + p;
            }
            *yylexp = (YYINT) YYLEX;
            *yylvp++ = yylval;
            yylve++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            *yylpp++ = yylloc;
            yylpe++;
#endif
            yychar = *yylexp++;
            break;
        }
        /* normal operation, no conflict encountered */
#endif /* YYBTYACC */
        yychar = YYLEX;
#if YYBTYACC
        } while (0);
#endif /* YYBTYACC */
        if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            fprintf(stderr, "%s[%d]: state %d, reading token %d (%s)",
                            YYDEBUGSTR, yydepth, yystate, yychar, yys);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
            if (!yytrial)
#endif /* YYBTYACC */
                fprintf(stderr, " <%s>", YYSTYPE_TOSTRING(yychar, yylval));
#endif
            fputc('\n', stderr);
        }
#endif
    }
#if YYBTYACC

    /* Do we have a conflict? */
    if (((yyn = yycindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
        yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        YYINT ctry;

        if (yypath)
        {
            YYParseState *save;
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%s[%d]: CONFLICT in state %d: following successful trial parse\n",
                                YYDEBUGSTR, yydepth, yystate);
#endif
            /* Switch to the next conflict context */
            save = yypath;
            yypath = save->save;
            save->save = NULL;
            ctry = save->ctry;
            if (save->state != yystate) YYABORT;
            yyFreeState(save);

        }
        else
        {

            /* Unresolved conflict - start/continue trial parse */
            YYParseState *save;
#if YYDEBUG
            if (yydebug)
            {
                fprintf(stderr, "%s[%d]: CONFLICT in state %d. ", YYDEBUGSTR, yydepth, yystate);
                if (yyps->save)
                    fputs("ALREADY in conflict, continuing trial parse.\n", stderr);
                else
                    fputs("Starting trial parse.\n", stderr);
            }
#endif
            save                  = yyNewState((unsigned)(yystack.s_mark - yystack.s_base + 1));
            if (save == NULL) goto yyenomem;
            save->save            = yyps->save;
            save->state           = yystate;
            save->errflag         = yyerrflag;
            save->yystack.s_mark  = save->yystack.s_base + (yystack.s_mark - yystack.s_base);
            memcpy (save->yystack.s_base, yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            save->yystack.l_mark  = save->yystack.l_base + (yystack.l_mark - yystack.l_base);
            memcpy (save->yystack.l_base, yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            save->yystack.p_mark  = save->yystack.p_base + (yystack.p_mark - yystack.p_base);
            memcpy (save->yystack.p_base, yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            ctry                  = yytable[yyn];
            if (yyctable[ctry] == -1)
            {
#if YYDEBUG
                if (yydebug && yychar >= YYEOF)
                    fprintf(stderr, "%s[%d]: backtracking 1 token\n", YYDEBUGSTR, yydepth);
#endif
                ctry++;
            }
            save->ctry = ctry;
            if (yyps->save == NULL)
            {
                /* If this is a first conflict in the stack, start saving lexemes */
                if (!yylexemes)
                {
                    yylexemes = (YYINT *) malloc((YYLVQUEUEGROWTH) * sizeof(YYINT));
                    if (yylexemes == NULL) goto yyenomem;
                    yylvals   = (YYSTYPE *) malloc((YYLVQUEUEGROWTH) * sizeof(YYSTYPE));
                    if (yylvals == NULL) goto yyenomem;
                    yylvlim   = yylvals + YYLVQUEUEGROWTH;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpsns   = (YYLTYPE *) malloc((YYLVQUEUEGROWTH) * sizeof(YYLTYPE));
                    if (yylpsns == NULL) goto yyenomem;
                    yylplim   = yylpsns + YYLVQUEUEGROWTH;
#endif
                }
                if (yylvp == yylve)
                {
                    yylvp  = yylve = yylvals;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpp  = yylpe = yylpsns;
#endif
                    yylexp = yylexemes;
                    if (yychar >= YYEOF)
                    {
                        *yylve++ = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                        *yylpe++ = yylloc;
#endif
                        *yylexp  = (YYINT) yychar;
                        yychar   = YYEMPTY;
                    }
                }
            }
            if (yychar >= YYEOF)
            {
                yylvp--;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp--;
#endif
                yylexp--;
                yychar = YYEMPTY;
            }
            save->lexeme = (int) (yylvp - yylvals);
            yyps->save   = save;
        }
        if (yytable[yyn] == ctry)
        {
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%s[%d]: state %d, shifting to state %d\n",
                                YYDEBUGSTR, yydepth, yystate, yyctable[ctry]);
#endif
            if (yychar < 0)
            {
                yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylpp++;
#endif
                yylexp++;
            }
            if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM)
                goto yyoverflow;
            yystate = yyctable[ctry];
            *++yystack.s_mark = (YYINT) yystate;
            *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            *++yystack.p_mark = yylloc;
#endif
            yychar  = YYEMPTY;
            if (yyerrflag > 0) --yyerrflag;
            goto yyloop;
        }
        else
        {
            yyn = yyctable[ctry];
            goto yyreduce;
        }
    } /* End of code dealing with conflicts */
#endif /* YYBTYACC */
    if (((yyn = yysindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
#if YYDEBUG
        if (yydebug)
            fprintf(stderr, "%s[%d]: state %d, shifting to state %d\n",
                            YYDEBUGSTR, yydepth, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        *++yystack.p_mark = yylloc;
#endif
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if (((yyn = yyrindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag != 0) goto yyinrecovery;
#if YYBTYACC

    yynewerrflag = 1;
    goto yyerrhandler;
    goto yyerrlab; /* redundant goto avoids 'unused label' warning */

yyerrlab:
    /* explicit YYERROR from an action -- pop the rhs of the rule reduced
     * before looking for error recovery */
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark -= yym;
#endif

    yynewerrflag = 0;
yyerrhandler:
    while (yyps->save)
    {
        int ctry;
        YYParseState *save = yyps->save;
#if YYDEBUG
        if (yydebug)
            fprintf(stderr, "%s[%d]: ERROR in state %d, CONFLICT BACKTRACKING to state %d, %d tokens\n",
                            YYDEBUGSTR, yydepth, yystate, yyps->save->state,
                    (int)(yylvp - yylvals - yyps->save->lexeme));
#endif
        /* Memorize most forward-looking error state in case it's really an error. */
        if (yyerrctx == NULL || yyerrctx->lexeme < yylvp - yylvals)
        {
            /* Free old saved error context state */
            if (yyerrctx) yyFreeState(yyerrctx);
            /* Create and fill out new saved error context state */
            yyerrctx                 = yyNewState((unsigned)(yystack.s_mark - yystack.s_base + 1));
            if (yyerrctx == NULL) goto yyenomem;
            yyerrctx->save           = yyps->save;
            yyerrctx->state          = yystate;
            yyerrctx->errflag        = yyerrflag;
            yyerrctx->yystack.s_mark = yyerrctx->yystack.s_base + (yystack.s_mark - yystack.s_base);
            memcpy (yyerrctx->yystack.s_base, yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            yyerrctx->yystack.l_mark = yyerrctx->yystack.l_base + (yystack.l_mark - yystack.l_base);
            memcpy (yyerrctx->yystack.l_base, yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yyerrctx->yystack.p_mark = yyerrctx->yystack.p_base + (yystack.p_mark - yystack.p_base);
            memcpy (yyerrctx->yystack.p_base, yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            yyerrctx->lexeme         = (int) (yylvp - yylvals);
        }
        yylvp          = yylvals   + save->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        yylpp          = yylpsns   + save->lexeme;
#endif
        yylexp         = yylexemes + save->lexeme;
        yychar         = YYEMPTY;
        yystack.s_mark = yystack.s_base + (save->yystack.s_mark - save->yystack.s_base);
        memcpy (yystack.s_base, save->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
        yystack.l_mark = yystack.l_base + (save->yystack.l_mark - save->yystack.l_base);
        memcpy (yystack.l_base, save->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        yystack.p_mark = yystack.p_base + (save->yystack.p_mark - save->yystack.p_base);
        memcpy (yystack.p_base, save->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
        ctry           = ++save->ctry;
        yystate        = save->state;
        /* We tried shift, try reduce now */
        if ((yyn = yyctable[ctry]) >= 0) goto yyreduce;
        yyps->save     = save->save;
        save->save     = NULL;
        yyFreeState(save);

        /* Nothing left on the stack -- error */
        if (!yyps->save)
        {
#if YYDEBUG
            if (yydebug)
                fprintf(stderr, "%sdebug[%d,trial]: trial parse FAILED, entering ERROR mode\n",
                                YYPREFIX, yydepth);
#endif
            /* Restore state as it was in the most forward-advanced error */
            yylvp          = yylvals   + yyerrctx->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylpp          = yylpsns   + yyerrctx->lexeme;
#endif
            yylexp         = yylexemes + yyerrctx->lexeme;
            yychar         = yylexp[-1];
            yylval         = yylvp[-1];
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yylloc         = yylpp[-1];
#endif
            yystack.s_mark = yystack.s_base + (yyerrctx->yystack.s_mark - yyerrctx->yystack.s_base);
            memcpy (yystack.s_base, yyerrctx->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
            yystack.l_mark = yystack.l_base + (yyerrctx->yystack.l_mark - yyerrctx->yystack.l_base);
            memcpy (yystack.l_base, yyerrctx->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            yystack.p_mark = yystack.p_base + (yyerrctx->yystack.p_mark - yyerrctx->yystack.p_base);
            memcpy (yystack.p_base, yyerrctx->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
            yystate        = yyerrctx->state;
            yyFreeState(yyerrctx);
            yyerrctx       = NULL;
        }
        yynewerrflag = 1;
    }
    if (yynewerrflag == 0) goto yyinrecovery;
#endif /* YYBTYACC */

    YYERROR_CALL("syntax error");
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yyerror_loc_range[1] = yylloc; /* lookahead position is error start position */
#endif

#if !YYBTYACC
    goto yyerrlab; /* redundant goto avoids 'unused label' warning */
yyerrlab:
#endif
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if (((yyn = yysindex[*yystack.s_mark]) != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    fprintf(stderr, "%s[%d]: state %d, error recovery shifting to state %d\n",
                                    YYDEBUGSTR, yydepth, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                /* lookahead position is error end position */
                yyerror_loc_range[2] = yylloc;
                YYLLOC_DEFAULT(yyloc, yyerror_loc_range, 2); /* position of error span */
                *++yystack.p_mark = yyloc;
#endif
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    fprintf(stderr, "%s[%d]: error recovery discarding state %d\n",
                                    YYDEBUGSTR, yydepth, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                /* the current TOS position is the error start position */
                yyerror_loc_range[1] = *yystack.p_mark;
#endif
#if defined(YYDESTRUCT_CALL)
#if YYBTYACC
                if (!yytrial)
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    YYDESTRUCT_CALL("error: discarding state",
                                    yystos[*yystack.s_mark], yystack.l_mark, yystack.p_mark);
#else
                    YYDESTRUCT_CALL("error: discarding state",
                                    yystos[*yystack.s_mark], yystack.l_mark);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#endif /* defined(YYDESTRUCT_CALL) */
                --yystack.s_mark;
                --yystack.l_mark;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                --yystack.p_mark;
#endif
            }
        }
    }
    else
    {
        if (yychar == YYEOF) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            fprintf(stderr, "%s[%d]: state %d, error recovery discarding token %d (%s)\n",
                            YYDEBUGSTR, yydepth, yystate, yychar, yys);
        }
#endif
#if defined(YYDESTRUCT_CALL)
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
            YYDESTRUCT_CALL("error: discarding token", yychar, &yylval, &yylloc);
#else
            YYDESTRUCT_CALL("error: discarding token", yychar, &yylval);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
#endif /* defined(YYDESTRUCT_CALL) */
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
    yym = yylen[yyn];
#if YYDEBUG
    if (yydebug)
    {
        fprintf(stderr, "%s[%d]: state %d, reducing by rule %d (%s)",
                        YYDEBUGSTR, yydepth, yystate, yyn, yyrule[yyn]);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
            if (yym > 0)
            {
                int i;
                fputc('<', stderr);
                for (i = yym; i > 0; i--)
                {
                    if (i != yym) fputs(", ", stderr);
                    fputs(YYSTYPE_TOSTRING(yystos[yystack.s_mark[1-i]],
                                           yystack.l_mark[1-i]), stderr);
                }
                fputc('>', stderr);
            }
#endif
        fputc('\n', stderr);
    }
#endif
    if (yym > 0)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)

    /* Perform position reduction */
    memset(&yyloc, 0, sizeof(yyloc));
#if YYBTYACC
    if (!yytrial)
#endif /* YYBTYACC */
    {
        YYLLOC_DEFAULT(yyloc, &yystack.p_mark[-yym], yym);
        /* just in case YYERROR is invoked within the action, save
           the start of the rhs as the error start position */
        yyerror_loc_range[1] = yystack.p_mark[1-yym];
    }
#endif

    switch (yyn)
    {
case 9:
#line 493 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ file->errors++; }
#line 3830 "parse.c"
break;
case 12:
#line 500 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			struct file	*nfile;

			if ((nfile = pushfile(yystack.l_mark[0].v.string, 1)) == NULL) {
				yyerror("failed to include file %s", yystack.l_mark[0].v.string);
				free(yystack.l_mark[0].v.string);
				YYERROR;
			}
			free(yystack.l_mark[0].v.string);

			file = nfile;
			lungetc('\n');
		}
#line 3847 "parse.c"
break;
case 13:
#line 515 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ passive = 0; }
#line 3852 "parse.c"
break;
case 14:
#line 516 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ passive = 1; }
#line 3857 "parse.c"
break;
case 15:
#line 517 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ decouple = 0; }
#line 3862 "parse.c"
break;
case 16:
#line 518 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ decouple = 1; }
#line 3867 "parse.c"
break;
case 17:
#line 519 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ fragmentation = 1; }
#line 3872 "parse.c"
break;
case 18:
#line 520 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ fragmentation = 0; }
#line 3877 "parse.c"
break;
case 19:
#line 521 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ mobike = 1; }
#line 3882 "parse.c"
break;
case 20:
#line 522 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ mobike = 0; }
#line 3887 "parse.c"
break;
case 21:
#line 523 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ vendorid = 1; }
#line 3892 "parse.c"
break;
case 22:
#line 524 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ vendorid = 0; }
#line 3897 "parse.c"
break;
case 23:
#line 525 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ enforcesingleikesa = 1; }
#line 3902 "parse.c"
break;
case 24:
#line 526 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ enforcesingleikesa = 0; }
#line 3907 "parse.c"
break;
case 25:
#line 527 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ stickyaddress = 1; }
#line 3912 "parse.c"
break;
case 26:
#line 528 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ stickyaddress = 0; }
#line 3917 "parse.c"
break;
case 27:
#line 529 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			ocsp_url = yystack.l_mark[0].v.string;
		}
#line 3924 "parse.c"
break;
case 28:
#line 532 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			ocsp_url = yystack.l_mark[-2].v.string;
			ocsp_tolerate = yystack.l_mark[0].v.number;
		}
#line 3932 "parse.c"
break;
case 29:
#line 536 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			ocsp_url = yystack.l_mark[-4].v.string;
			ocsp_tolerate = yystack.l_mark[-2].v.number;
			ocsp_maxage = yystack.l_mark[0].v.number;
		}
#line 3941 "parse.c"
break;
case 30:
#line 541 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			cert_partial_chain = 1;
		}
#line 3948 "parse.c"
break;
case 31:
#line 544 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			if (yystack.l_mark[0].v.number < 0) {
				yyerror("timeout outside range");
				YYERROR;
			}
			dpd_interval = yystack.l_mark[0].v.number;
		}
#line 3959 "parse.c"
break;
case 32:
#line 553 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			if (create_user(yystack.l_mark[-1].v.string, yystack.l_mark[0].v.string) == -1)
				YYERROR;
			free(yystack.l_mark[-1].v.string);
			freezero(yystack.l_mark[0].v.string, strlen(yystack.l_mark[0].v.string));
		}
#line 3969 "parse.c"
break;
case 33:
#line 563 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			if (create_ike(yystack.l_mark[-16].v.string, yystack.l_mark[-13].v.number, yystack.l_mark[-12].v.proto, yystack.l_mark[-11].v.number, yystack.l_mark[-10].v.hosts, &yystack.l_mark[-9].v.peers, yystack.l_mark[-8].v.mode, yystack.l_mark[-7].v.mode, yystack.l_mark[-14].v.satype,
			    yystack.l_mark[-15].v.ikemode, yystack.l_mark[-6].v.ids.srcid, yystack.l_mark[-6].v.ids.dstid, yystack.l_mark[-5].v.number, &yystack.l_mark[-4].v.lifetime, &yystack.l_mark[-3].v.ikeauth,
			    yystack.l_mark[0].v.filters, yystack.l_mark[-2].v.cfg, yystack.l_mark[-1].v.string) == -1) {
				yyerror("create_ike failed");
				YYERROR;
			}
		}
#line 3981 "parse.c"
break;
case 34:
#line 573 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.cfg = NULL; }
#line 3986 "parse.c"
break;
case 35:
#line 574 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.cfg = yystack.l_mark[0].v.cfg; }
#line 3991 "parse.c"
break;
case 36:
#line 577 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.cfg = yystack.l_mark[0].v.cfg; }
#line 3996 "parse.c"
break;
case 37:
#line 578 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			if (yystack.l_mark[0].v.cfg == NULL)
				yyval.v.cfg = yystack.l_mark[-1].v.cfg;
			else if (yystack.l_mark[-1].v.cfg == NULL)
				yyval.v.cfg = yystack.l_mark[0].v.cfg;
			else {
				yystack.l_mark[-1].v.cfg->tail->next = yystack.l_mark[0].v.cfg;
				yystack.l_mark[-1].v.cfg->tail = yystack.l_mark[0].v.cfg->tail;
				yyval.v.cfg = yystack.l_mark[-1].v.cfg;
			}
		}
#line 4011 "parse.c"
break;
case 38:
#line 591 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			const struct ipsec_xf	*xf;

			if ((xf = parse_xf(yystack.l_mark[-1].v.string, yystack.l_mark[0].v.host->af, cpxfs)) == NULL) {
				yyerror("not a valid ikecfg option");
				free(yystack.l_mark[-1].v.string);
				free(yystack.l_mark[0].v.host);
				YYERROR;
			}
			free(yystack.l_mark[-1].v.string);
			yyval.v.cfg = yystack.l_mark[0].v.host;
			yyval.v.cfg->type = xf->id;
			yyval.v.cfg->action = IKEV2_CP_REPLY;	/* XXX */
		}
#line 4029 "parse.c"
break;
case 39:
#line 605 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			const struct ipsec_xf	*xf;

			if ((xf = parse_xf(yystack.l_mark[-1].v.string, yystack.l_mark[0].v.anyhost->af, cpxfs)) == NULL) {
				yyerror("not a valid ikecfg option");
				free(yystack.l_mark[-1].v.string);
				free(yystack.l_mark[0].v.anyhost);
				YYERROR;
			}
			free(yystack.l_mark[-1].v.string);
			yyval.v.cfg = yystack.l_mark[0].v.anyhost;
			yyval.v.cfg->type = xf->id;
			yyval.v.cfg->action = IKEV2_CP_REQUEST;	/* XXX */
		}
#line 4047 "parse.c"
break;
case 40:
#line 621 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.string = NULL; }
#line 4052 "parse.c"
break;
case 41:
#line 622 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.string = yystack.l_mark[0].v.string;
		}
#line 4059 "parse.c"
break;
case 42:
#line 626 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.satype = IKEV2_SAPROTO_ESP; }
#line 4064 "parse.c"
break;
case 43:
#line 627 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.satype = IKEV2_SAPROTO_ESP; }
#line 4069 "parse.c"
break;
case 44:
#line 628 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.satype = IKEV2_SAPROTO_AH; }
#line 4074 "parse.c"
break;
case 45:
#line 631 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.number = AF_UNSPEC; }
#line 4079 "parse.c"
break;
case 46:
#line 632 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.number = AF_INET; }
#line 4084 "parse.c"
break;
case 47:
#line 633 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.number = AF_INET6; }
#line 4089 "parse.c"
break;
case 48:
#line 636 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.proto = NULL; }
#line 4094 "parse.c"
break;
case 49:
#line 637 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.proto = yystack.l_mark[0].v.proto; }
#line 4099 "parse.c"
break;
case 50:
#line 638 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.proto = yystack.l_mark[-1].v.proto; }
#line 4104 "parse.c"
break;
case 51:
#line 641 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.proto = yystack.l_mark[0].v.proto; }
#line 4109 "parse.c"
break;
case 52:
#line 642 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			if (yystack.l_mark[0].v.proto == NULL)
				yyval.v.proto = yystack.l_mark[-2].v.proto;
			else if (yystack.l_mark[-2].v.proto == NULL)
				yyval.v.proto = yystack.l_mark[0].v.proto;
			else {
				yystack.l_mark[-2].v.proto->tail->next = yystack.l_mark[0].v.proto;
				yystack.l_mark[-2].v.proto->tail = yystack.l_mark[0].v.proto->tail;
				yyval.v.proto = yystack.l_mark[-2].v.proto;
			}
		}
#line 4124 "parse.c"
break;
case 53:
#line 655 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			struct protoent *p;

			p = getprotobyname(yystack.l_mark[0].v.string);
			if (p == NULL) {
				yyerror("unknown protocol: %s", yystack.l_mark[0].v.string);
				YYERROR;
			}

			if ((yyval.v.proto = calloc(1, sizeof(*yyval.v.proto))) == NULL)
				err(1, "protoval: calloc");

			yyval.v.proto->type = p->p_proto;
			yyval.v.proto->tail = yyval.v.proto;
			free(yystack.l_mark[0].v.string);
		}
#line 4144 "parse.c"
break;
case 54:
#line 671 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			if (yystack.l_mark[0].v.number > 255 || yystack.l_mark[0].v.number < 0) {
				yyerror("protocol outside range");
				YYERROR;
			}
			if ((yyval.v.proto = calloc(1, sizeof(*yyval.v.proto))) == NULL)
				err(1, "protoval: calloc");

			yyval.v.proto->type = yystack.l_mark[0].v.number;
			yyval.v.proto->tail = yyval.v.proto;
		}
#line 4159 "parse.c"
break;
case 55:
#line 684 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.number = -1; }
#line 4164 "parse.c"
break;
case 56:
#line 685 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
#ifdef SADB_X_EXT_RDOMAIN
			if (yystack.l_mark[0].v.number > 255 || yystack.l_mark[0].v.number < 0) {
				yyerror("rdomain outside range");
				YYERROR;
			}
			yyval.v.number = yystack.l_mark[0].v.number;
#else
			yyerror("'rdomain' is not supported on this platform");
			YYERROR;
#endif
		}
#line 4180 "parse.c"
break;
case 57:
#line 698 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.hosts = yystack.l_mark[0].v.hosts; }
#line 4185 "parse.c"
break;
case 58:
#line 699 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			if (yystack.l_mark[0].v.hosts == NULL)
				yyval.v.hosts = yystack.l_mark[-2].v.hosts;
			else if (yystack.l_mark[-2].v.hosts == NULL)
				yyval.v.hosts = yystack.l_mark[0].v.hosts;
			else {
				yystack.l_mark[-2].v.hosts->src->tail->next = yystack.l_mark[0].v.hosts->src;
				yystack.l_mark[-2].v.hosts->src->tail = yystack.l_mark[0].v.hosts->src->tail;
				yystack.l_mark[-2].v.hosts->dst->tail->next = yystack.l_mark[0].v.hosts->dst;
				yystack.l_mark[-2].v.hosts->dst->tail = yystack.l_mark[0].v.hosts->dst->tail;
				yyval.v.hosts = yystack.l_mark[-2].v.hosts;
				free(yystack.l_mark[0].v.hosts);
			}
		}
#line 4203 "parse.c"
break;
case 59:
#line 715 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			struct ipsec_addr_wrap *ipa;
			for (ipa = yystack.l_mark[-1].v.host; ipa; ipa = ipa->next) {
				if (ipa->srcnat) {
					yyerror("no flow NAT support for"
					    " destination network: %s",
					    ipa->name);
					YYERROR;
				}
			}

			if ((yyval.v.hosts = calloc(1, sizeof(*yyval.v.hosts))) == NULL)
				err(1, "hosts: calloc");

			yyval.v.hosts->src = yystack.l_mark[-4].v.host;
			yyval.v.hosts->src->port = yystack.l_mark[-3].v.port;
			yyval.v.hosts->dst = yystack.l_mark[-1].v.host;
			yyval.v.hosts->dst->port = yystack.l_mark[0].v.port;
		}
#line 4226 "parse.c"
break;
case 60:
#line 734 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			struct ipsec_addr_wrap *ipa;
			for (ipa = yystack.l_mark[-4].v.host; ipa; ipa = ipa->next) {
				if (ipa->srcnat) {
					yyerror("no flow NAT support for"
					    " destination network: %s",
					    ipa->name);
					YYERROR;
				}
			}
			if ((yyval.v.hosts = calloc(1, sizeof(*yyval.v.hosts))) == NULL)
				err(1, "hosts: calloc");

			yyval.v.hosts->src = yystack.l_mark[-1].v.host;
			yyval.v.hosts->src->port = yystack.l_mark[0].v.port;
			yyval.v.hosts->dst = yystack.l_mark[-4].v.host;
			yyval.v.hosts->dst->port = yystack.l_mark[-3].v.port;
		}
#line 4248 "parse.c"
break;
case 61:
#line 754 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.port = 0; }
#line 4253 "parse.c"
break;
case 62:
#line 755 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.port = yystack.l_mark[0].v.number; }
#line 4258 "parse.c"
break;
case 63:
#line 758 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			struct servent *s;

			if ((s = getservbyname(yystack.l_mark[0].v.string, "tcp")) != NULL ||
			    (s = getservbyname(yystack.l_mark[0].v.string, "udp")) != NULL) {
				yyval.v.number = s->s_port;
			} else {
				yyerror("unknown port: %s", yystack.l_mark[0].v.string);
				YYERROR;
			}
			free(yystack.l_mark[0].v.string);
		}
#line 4274 "parse.c"
break;
case 64:
#line 770 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			if (yystack.l_mark[0].v.number > USHRT_MAX || yystack.l_mark[0].v.number < 0) {
				yyerror("port outside range");
				YYERROR;
			}
			yyval.v.number = htons(yystack.l_mark[0].v.number);
		}
#line 4285 "parse.c"
break;
case 65:
#line 779 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.peers.dst = NULL;
			yyval.v.peers.src = NULL;
		}
#line 4293 "parse.c"
break;
case 66:
#line 783 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.peers.dst = yystack.l_mark[-2].v.anyhost;
			yyval.v.peers.src = yystack.l_mark[0].v.anyhost;
		}
#line 4301 "parse.c"
break;
case 67:
#line 787 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.peers.dst = yystack.l_mark[0].v.anyhost;
			yyval.v.peers.src = yystack.l_mark[-2].v.anyhost;
		}
#line 4309 "parse.c"
break;
case 68:
#line 791 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.peers.dst = yystack.l_mark[0].v.anyhost;
			yyval.v.peers.src = NULL;
		}
#line 4317 "parse.c"
break;
case 69:
#line 795 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.peers.dst = NULL;
			yyval.v.peers.src = yystack.l_mark[0].v.anyhost;
		}
#line 4325 "parse.c"
break;
case 70:
#line 801 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.anyhost = yystack.l_mark[0].v.host; }
#line 4330 "parse.c"
break;
case 71:
#line 802 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.anyhost = host_any();
		}
#line 4337 "parse.c"
break;
case 72:
#line 806 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			if ((yyval.v.host = host(yystack.l_mark[0].v.string)) == NULL) {
				free(yystack.l_mark[0].v.string);
				yyerror("could not parse host specification");
				YYERROR;
			}
			free(yystack.l_mark[0].v.string);
		}
#line 4349 "parse.c"
break;
case 73:
#line 814 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			char	*buf;

			if (asprintf(&buf, "%s/%lld", yystack.l_mark[-2].v.string, (long long)yystack.l_mark[0].v.number) == -1)
				err(1, "host: asprintf");
			free(yystack.l_mark[-2].v.string);
			if ((yyval.v.host = host(buf)) == NULL)	{
				free(buf);
				yyerror("could not parse host specification");
				YYERROR;
			}
			free(buf);
		}
#line 4366 "parse.c"
break;
case 74:
#line 829 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.host = yystack.l_mark[0].v.host; }
#line 4371 "parse.c"
break;
case 75:
#line 830 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			if ((yystack.l_mark[-3].v.host->af != AF_UNSPEC) && (yystack.l_mark[-1].v.host->af != AF_UNSPEC) &&
			    (yystack.l_mark[-1].v.host->af != yystack.l_mark[-3].v.host->af)) {
				yyerror("Flow NAT address family mismatch");
				YYERROR;
			}
			yyval.v.host = yystack.l_mark[-3].v.host;
			yyval.v.host->srcnat = yystack.l_mark[-1].v.host;
		}
#line 4384 "parse.c"
break;
case 76:
#line 839 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.host = host_any();
		}
#line 4391 "parse.c"
break;
case 77:
#line 842 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.host = host_dynamic();
		}
#line 4398 "parse.c"
break;
case 78:
#line 847 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.ids.srcid = NULL;
			yyval.v.ids.dstid = NULL;
		}
#line 4406 "parse.c"
break;
case 79:
#line 851 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.ids.srcid = yystack.l_mark[-2].v.id;
			yyval.v.ids.dstid = yystack.l_mark[0].v.id;
		}
#line 4414 "parse.c"
break;
case 80:
#line 855 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.ids.srcid = yystack.l_mark[0].v.id;
			yyval.v.ids.dstid = NULL;
		}
#line 4422 "parse.c"
break;
case 81:
#line 859 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.ids.srcid = NULL;
			yyval.v.ids.dstid = yystack.l_mark[0].v.id;
		}
#line 4430 "parse.c"
break;
case 82:
#line 865 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.id = yystack.l_mark[0].v.string; }
#line 4435 "parse.c"
break;
case 83:
#line 868 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			if ((ipsec_transforms = calloc(1,
			    sizeof(struct ipsec_transforms))) == NULL)
				err(1, "transforms: calloc");
		}
#line 4444 "parse.c"
break;
case 84:
#line 873 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.transforms = ipsec_transforms;
		}
#line 4451 "parse.c"
break;
case 85:
#line 876 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.transforms = NULL;
		}
#line 4458 "parse.c"
break;
case 88:
#line 885 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			const struct ipsec_xf **xfs = ipsec_transforms->authxf;
			size_t nxfs = ipsec_transforms->nauthxf;
			xfs = recallocarray(xfs, nxfs, nxfs + 1,
			    sizeof(struct ipsec_xf *));
			if (xfs == NULL)
				err(1, "transform: recallocarray");
			if ((xfs[nxfs] = parse_xf(yystack.l_mark[0].v.string, 0, authxfs)) == NULL) {
				yyerror("%s not a valid transform", yystack.l_mark[0].v.string);
				YYERROR;
			}
			free(yystack.l_mark[0].v.string);
			ipsec_transforms->authxf = xfs;
			ipsec_transforms->nauthxf++;
		}
#line 4477 "parse.c"
break;
case 89:
#line 900 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			const struct ipsec_xf **xfs = ipsec_transforms->encxf;
			size_t nxfs = ipsec_transforms->nencxf;
			xfs = recallocarray(xfs, nxfs, nxfs + 1,
			    sizeof(struct ipsec_xf *));
			if (xfs == NULL)
				err(1, "transform: recallocarray");
			if ((xfs[nxfs] = parse_xf(yystack.l_mark[0].v.string, 0, encxfs)) == NULL) {
				yyerror("%s not a valid transform", yystack.l_mark[0].v.string);
				YYERROR;
			}
			free(yystack.l_mark[0].v.string);
			ipsec_transforms->encxf = xfs;
			ipsec_transforms->nencxf++;
		}
#line 4496 "parse.c"
break;
case 90:
#line 915 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			const struct ipsec_xf **xfs = ipsec_transforms->prfxf;
			size_t nxfs = ipsec_transforms->nprfxf;
			xfs = recallocarray(xfs, nxfs, nxfs + 1,
			    sizeof(struct ipsec_xf *));
			if (xfs == NULL)
				err(1, "transform: recallocarray");
			if ((xfs[nxfs] = parse_xf(yystack.l_mark[0].v.string, 0, prfxfs)) == NULL) {
				yyerror("%s not a valid transform", yystack.l_mark[0].v.string);
				YYERROR;
			}
			free(yystack.l_mark[0].v.string);
			ipsec_transforms->prfxf = xfs;
			ipsec_transforms->nprfxf++;
		}
#line 4515 "parse.c"
break;
case 91:
#line 930 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			const struct ipsec_xf **xfs = ipsec_transforms->groupxf;
			size_t nxfs = ipsec_transforms->ngroupxf;
			xfs = recallocarray(xfs, nxfs, nxfs + 1,
			    sizeof(struct ipsec_xf *));
			if (xfs == NULL)
				err(1, "transform: recallocarray");
			if ((xfs[nxfs] = parse_xf(yystack.l_mark[0].v.string, 0, groupxfs)) == NULL) {
				yyerror("%s not a valid transform", yystack.l_mark[0].v.string);
				YYERROR;
			}
			free(yystack.l_mark[0].v.string);
			ipsec_transforms->groupxf = xfs;
			ipsec_transforms->ngroupxf++;
		}
#line 4534 "parse.c"
break;
case 92:
#line 945 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			const struct ipsec_xf **xfs = ipsec_transforms->esnxf;
			size_t nxfs = ipsec_transforms->nesnxf;
			xfs = recallocarray(xfs, nxfs, nxfs + 1,
			    sizeof(struct ipsec_xf *));
			if (xfs == NULL)
				err(1, "transform: recallocarray");
			if ((xfs[nxfs] = parse_xf(yystack.l_mark[0].v.string, 0, esnxfs)) == NULL) {
				yyerror("%s not a valid transform", yystack.l_mark[0].v.string);
				YYERROR;
			}
			ipsec_transforms->esnxf = xfs;
			ipsec_transforms->nesnxf++;
		}
#line 4552 "parse.c"
break;
case 93:
#line 961 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.string = "esn"; }
#line 4557 "parse.c"
break;
case 94:
#line 962 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.string = "noesn"; }
#line 4562 "parse.c"
break;
case 95:
#line 965 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			if ((ipsec_mode = calloc(1,
			    sizeof(struct ipsec_mode))) == NULL)
				err(1, "ike_sas: calloc");
		}
#line 4571 "parse.c"
break;
case 96:
#line 970 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.mode = ipsec_mode;
		}
#line 4578 "parse.c"
break;
case 97:
#line 973 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.mode = NULL;
		}
#line 4585 "parse.c"
break;
case 100:
#line 982 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			if ((ipsec_mode->xfs = recallocarray(ipsec_mode->xfs,
			    ipsec_mode->nxfs, ipsec_mode->nxfs + 1,
			    sizeof(struct ipsec_transforms *))) == NULL)
				err(1, "ike_sa: recallocarray");
			ipsec_mode->nxfs++;
			encxfs = ikeencxfs;
		}
#line 4597 "parse.c"
break;
case 101:
#line 989 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			ipsec_mode->xfs[ipsec_mode->nxfs - 1] = yystack.l_mark[0].v.transforms;
		}
#line 4604 "parse.c"
break;
case 102:
#line 994 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			if ((ipsec_mode = calloc(1,
			    sizeof(struct ipsec_mode))) == NULL)
				err(1, "child_sas: calloc");
		}
#line 4613 "parse.c"
break;
case 103:
#line 999 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.mode = ipsec_mode;
		}
#line 4620 "parse.c"
break;
case 104:
#line 1002 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.mode = NULL;
		}
#line 4627 "parse.c"
break;
case 107:
#line 1011 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			if ((ipsec_mode->xfs = recallocarray(ipsec_mode->xfs,
			    ipsec_mode->nxfs, ipsec_mode->nxfs + 1,
			    sizeof(struct ipsec_transforms *))) == NULL)
				err(1, "child_sa: recallocarray");
			ipsec_mode->nxfs++;
			encxfs = ipsecencxfs;
		}
#line 4639 "parse.c"
break;
case 108:
#line 1018 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			ipsec_mode->xfs[ipsec_mode->nxfs - 1] = yystack.l_mark[0].v.transforms;
		}
#line 4646 "parse.c"
break;
case 109:
#line 1023 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.ikemode = yystack.l_mark[-3].v.ikemode | yystack.l_mark[-2].v.ikemode | yystack.l_mark[-1].v.ikemode | yystack.l_mark[0].v.ikemode; }
#line 4651 "parse.c"
break;
case 110:
#line 1026 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.ikemode = 0; }
#line 4656 "parse.c"
break;
case 111:
#line 1027 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.ikemode = IKED_POLICY_QUICK; }
#line 4661 "parse.c"
break;
case 112:
#line 1028 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.ikemode = IKED_POLICY_SKIP; }
#line 4666 "parse.c"
break;
case 113:
#line 1029 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.ikemode = IKED_POLICY_DEFAULT; }
#line 4671 "parse.c"
break;
case 114:
#line 1032 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.ikemode = IKED_POLICY_PASSIVE; }
#line 4676 "parse.c"
break;
case 115:
#line 1033 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.ikemode = IKED_POLICY_PASSIVE; }
#line 4681 "parse.c"
break;
case 116:
#line 1034 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.ikemode = IKED_POLICY_ACTIVE; }
#line 4686 "parse.c"
break;
case 117:
#line 1037 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.ikemode = 0; }
#line 4691 "parse.c"
break;
case 118:
#line 1038 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.ikemode = IKED_POLICY_IPCOMP; }
#line 4696 "parse.c"
break;
case 119:
#line 1041 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.ikemode = 0; }
#line 4701 "parse.c"
break;
case 120:
#line 1042 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.ikemode = 0; }
#line 4706 "parse.c"
break;
case 121:
#line 1043 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{ yyval.v.ikemode = IKED_POLICY_TRANSPORT; }
#line 4711 "parse.c"
break;
case 122:
#line 1046 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.ikeauth.auth_method = IKEV2_AUTH_SIG_ANY;	/* default */
			yyval.v.ikeauth.auth_eap = 0;
			yyval.v.ikeauth.auth_length = 0;
		}
#line 4720 "parse.c"
break;
case 123:
#line 1051 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			memcpy(&yyval.v.ikeauth, &yystack.l_mark[0].v.ikekey, sizeof(yyval.v.ikeauth));
			yyval.v.ikeauth.auth_method = IKEV2_AUTH_SHARED_KEY_MIC;
			yyval.v.ikeauth.auth_eap = 0;
			explicit_bzero(&yystack.l_mark[0].v.ikekey, sizeof(yystack.l_mark[0].v.ikekey));
		}
#line 4730 "parse.c"
break;
case 124:
#line 1057 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			unsigned int i;

			for (i = 0; i < strlen(yystack.l_mark[0].v.string); i++)
				if (yystack.l_mark[0].v.string[i] == '-')
					yystack.l_mark[0].v.string[i] = '_';

			if (strcasecmp("mschap_v2", yystack.l_mark[0].v.string) != 0) {
				yyerror("unsupported EAP method: %s", yystack.l_mark[0].v.string);
				free(yystack.l_mark[0].v.string);
				YYERROR;
			}
			free(yystack.l_mark[0].v.string);

			yyval.v.ikeauth.auth_method = IKEV2_AUTH_SIG_ANY;
			yyval.v.ikeauth.auth_eap = EAP_TYPE_MSCHAP_V2;
			yyval.v.ikeauth.auth_length = 0;
		}
#line 4752 "parse.c"
break;
case 125:
#line 1075 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			const struct ipsec_xf *xf;

			if ((xf = parse_xf(yystack.l_mark[0].v.string, 0, methodxfs)) == NULL ||
			    xf->id == IKEV2_AUTH_NONE) {
				yyerror("not a valid authentication mode");
				free(yystack.l_mark[0].v.string);
				YYERROR;
			}
			free(yystack.l_mark[0].v.string);

			yyval.v.ikeauth.auth_method = xf->id;
			yyval.v.ikeauth.auth_eap = 0;
			yyval.v.ikeauth.auth_length = 0;
		}
#line 4771 "parse.c"
break;
case 126:
#line 1092 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.number = yystack.l_mark[0].v.number;
		}
#line 4778 "parse.c"
break;
case 127:
#line 1095 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			uint64_t	 bytes = 0;
			char		 unit = 0;

			if (sscanf(yystack.l_mark[0].v.string, "%llu%c", (long long unsigned *)&bytes,
			    &unit) != 2) {
				yyerror("invalid byte specification: %s", yystack.l_mark[0].v.string);
				YYERROR;
			}
			free(yystack.l_mark[0].v.string);
			switch (toupper((unsigned char)unit)) {
			case 'K':
				bytes *= 1024;
				break;
			case 'M':
				bytes *= 1024 * 1024;
				break;
			case 'G':
				bytes *= 1024 * 1024 * 1024;
				break;
			default:
				yyerror("invalid byte unit");
				YYERROR;
			}
			yyval.v.number = bytes;
		}
#line 4808 "parse.c"
break;
case 128:
#line 1123 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.number = yystack.l_mark[0].v.number;
		}
#line 4815 "parse.c"
break;
case 129:
#line 1126 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			uint64_t	 seconds = 0;
			char		 unit = 0;

			if (sscanf(yystack.l_mark[0].v.string, "%llu%c", (long long unsigned *)&seconds,
			    &unit) != 2) {
				yyerror("invalid time specification: %s", yystack.l_mark[0].v.string);
				YYERROR;
			}
			free(yystack.l_mark[0].v.string);
			switch (tolower((unsigned char)unit)) {
			case 'm':
				seconds *= 60;
				break;
			case 'h':
				seconds *= 60 * 60;
				break;
			default:
				yyerror("invalid time unit");
				YYERROR;
			}
			yyval.v.number = seconds;
		}
#line 4842 "parse.c"
break;
case 130:
#line 1151 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.lifetime = deflifetime;
		}
#line 4849 "parse.c"
break;
case 131:
#line 1154 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.lifetime.lt_seconds = yystack.l_mark[0].v.number;
			yyval.v.lifetime.lt_bytes = deflifetime.lt_bytes;
		}
#line 4857 "parse.c"
break;
case 132:
#line 1158 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.lifetime.lt_seconds = yystack.l_mark[-2].v.number;
			yyval.v.lifetime.lt_bytes = yystack.l_mark[0].v.number;
		}
#line 4865 "parse.c"
break;
case 133:
#line 1164 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.number = 0;
		}
#line 4872 "parse.c"
break;
case 134:
#line 1167 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.number = yystack.l_mark[0].v.number;
		}
#line 4879 "parse.c"
break;
case 135:
#line 1171 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			uint8_t		*hex;

			bzero(&yyval.v.ikekey, sizeof(yyval.v.ikekey));

			hex = yystack.l_mark[0].v.string;
			if (strncmp(hex, "0x", 2) == 0) {
				hex += 2;
				if (parsekey(hex, strlen(hex), &yyval.v.ikekey) != 0) {
					free(yystack.l_mark[0].v.string);
					YYERROR;
				}
			} else {
				if (strlen(yystack.l_mark[0].v.string) > sizeof(yyval.v.ikekey.auth_data)) {
					yyerror("psk too long");
					free(yystack.l_mark[0].v.string);
					YYERROR;
				}
				strlcpy(yyval.v.ikekey.auth_data, yystack.l_mark[0].v.string,
				    sizeof(yyval.v.ikekey.auth_data));
				yyval.v.ikekey.auth_length = strlen(yystack.l_mark[0].v.string);
			}
			freezero(yystack.l_mark[0].v.string, strlen(yystack.l_mark[0].v.string));
		}
#line 4907 "parse.c"
break;
case 136:
#line 1195 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			if (parsekeyfile(yystack.l_mark[0].v.string, &yyval.v.ikekey) != 0) {
				free(yystack.l_mark[0].v.string);
				YYERROR;
			}
			free(yystack.l_mark[0].v.string);
		}
#line 4918 "parse.c"
break;
case 137:
#line 1204 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			if ((ipsec_filters = calloc(1,
			    sizeof(struct ipsec_filters))) == NULL)
				err(1, "filters: calloc");
		}
#line 4927 "parse.c"
break;
case 138:
#line 1209 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.filters = ipsec_filters;
		}
#line 4934 "parse.c"
break;
case 139:
#line 1212 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.filters = NULL;
		}
#line 4941 "parse.c"
break;
case 142:
#line 1222 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			ipsec_filters->tag = yystack.l_mark[0].v.string;
		}
#line 4948 "parse.c"
break;
case 143:
#line 1226 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			const char	*errstr = NULL;
			size_t		 len;

			len = strcspn(yystack.l_mark[0].v.string, "0123456789");
			if (strlen("enc") != len ||
			    strncmp("enc", yystack.l_mark[0].v.string, len) != 0) {
				yyerror("invalid tap interface name: %s", yystack.l_mark[0].v.string);
				free(yystack.l_mark[0].v.string);
				YYERROR;
			}
			ipsec_filters->tap =
			    strtonum(yystack.l_mark[0].v.string + len, 0, UINT_MAX, &errstr);
			free(yystack.l_mark[0].v.string);
			if (errstr != NULL) {
				yyerror("invalid tap interface unit: %s",
				    errstr);
				YYERROR;
			}
		}
#line 4972 "parse.c"
break;
case 144:
#line 1248 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.string = NULL;
		}
#line 4979 "parse.c"
break;
case 145:
#line 1251 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			yyval.v.string = yystack.l_mark[0].v.string;
		}
#line 4986 "parse.c"
break;
case 146:
#line 1256 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			if (asprintf(&yyval.v.string, "%s %s", yystack.l_mark[-1].v.string, yystack.l_mark[0].v.string) == -1)
				err(1, "string: asprintf");
			free(yystack.l_mark[-1].v.string);
			free(yystack.l_mark[0].v.string);
		}
#line 4996 "parse.c"
break;
case 148:
#line 1266 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			char *s = yystack.l_mark[-2].v.string;
			log_debug("%s = \"%s\"\n", yystack.l_mark[-2].v.string, yystack.l_mark[0].v.string);
			while (*s++) {
				if (isspace((unsigned char)*s)) {
					yyerror("macro name cannot contain "
					    "whitespace");
					free(yystack.l_mark[-2].v.string);
					free(yystack.l_mark[0].v.string);
					YYERROR;
				}
			}
			if (symset(yystack.l_mark[-2].v.string, yystack.l_mark[0].v.string, 0) == -1)
				err(1, "cannot store variable");
			free(yystack.l_mark[-2].v.string);
			free(yystack.l_mark[0].v.string);
		}
#line 5017 "parse.c"
break;
case 158:
#line 1304 "/builddir/build/BUILD/openiked-7.2/iked/parse.y"
	{
			int	 c;

			while ((c = lgetc(0)) != '\n' && c != EOF)
				; /* nothing */
			if (c == '\n')
				lungetc(c);
		}
#line 5029 "parse.c"
break;
#line 5031 "parse.c"
    default:
        break;
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark -= yym;
#endif
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
        {
            fprintf(stderr, "%s[%d]: after reduction, ", YYDEBUGSTR, yydepth);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
            if (!yytrial)
#endif /* YYBTYACC */
                fprintf(stderr, "result is <%s>, ", YYSTYPE_TOSTRING(yystos[YYFINAL], yyval));
#endif
            fprintf(stderr, "shifting from state 0 to final state %d\n", YYFINAL);
        }
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        *++yystack.p_mark = yyloc;
#endif
        if (yychar < 0)
        {
#if YYBTYACC
            do {
            if (yylvp < yylve)
            {
                /* we're currently re-reading tokens */
                yylval = *yylvp++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                yylloc = *yylpp++;
#endif
                yychar = *yylexp++;
                break;
            }
            if (yyps->save)
            {
                /* in trial mode; save scanner results for future parse attempts */
                if (yylvp == yylvlim)
                {   /* Enlarge lexical value queue */
                    size_t p = (size_t) (yylvp - yylvals);
                    size_t s = (size_t) (yylvlim - yylvals);

                    s += YYLVQUEUEGROWTH;
                    if ((yylexemes = (YYINT *)realloc(yylexemes, s * sizeof(YYINT))) == NULL)
                        goto yyenomem;
                    if ((yylvals   = (YYSTYPE *)realloc(yylvals, s * sizeof(YYSTYPE))) == NULL)
                        goto yyenomem;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    if ((yylpsns   = (YYLTYPE *)realloc(yylpsns, s * sizeof(YYLTYPE))) == NULL)
                        goto yyenomem;
#endif
                    yylvp   = yylve = yylvals + p;
                    yylvlim = yylvals + s;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                    yylpp   = yylpe = yylpsns + p;
                    yylplim = yylpsns + s;
#endif
                    yylexp  = yylexemes + p;
                }
                *yylexp = (YYINT) YYLEX;
                *yylvp++ = yylval;
                yylve++;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
                *yylpp++ = yylloc;
                yylpe++;
#endif
                yychar = *yylexp++;
                break;
            }
            /* normal operation, no conflict encountered */
#endif /* YYBTYACC */
            yychar = YYLEX;
#if YYBTYACC
            } while (0);
#endif /* YYBTYACC */
            if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
            if (yydebug)
            {
                if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
                fprintf(stderr, "%s[%d]: state %d, reading token %d (%s)\n",
                                YYDEBUGSTR, yydepth, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == YYEOF) goto yyaccept;
        goto yyloop;
    }
    if (((yyn = yygindex[yym]) != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
    {
        fprintf(stderr, "%s[%d]: after reduction, ", YYDEBUGSTR, yydepth);
#ifdef YYSTYPE_TOSTRING
#if YYBTYACC
        if (!yytrial)
#endif /* YYBTYACC */
            fprintf(stderr, "result is <%s>, ", YYSTYPE_TOSTRING(yystos[yystate], yyval));
#endif
        fprintf(stderr, "shifting from state %d to state %d\n", *yystack.s_mark, yystate);
    }
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    *++yystack.s_mark = (YYINT) yystate;
    *++yystack.l_mark = yyval;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    *++yystack.p_mark = yyloc;
#endif
    goto yyloop;
#if YYBTYACC

    /* Reduction declares that this path is valid. Set yypath and do a full parse */
yyvalid:
    if (yypath) YYABORT;
    while (yyps->save)
    {
        YYParseState *save = yyps->save;
        yyps->save = save->save;
        save->save = yypath;
        yypath = save;
    }
#if YYDEBUG
    if (yydebug)
        fprintf(stderr, "%s[%d]: state %d, CONFLICT trial successful, backtracking to state %d, %d tokens\n",
                        YYDEBUGSTR, yydepth, yystate, yypath->state, (int)(yylvp - yylvals - yypath->lexeme));
#endif
    if (yyerrctx)
    {
        yyFreeState(yyerrctx);
        yyerrctx = NULL;
    }
    yylvp          = yylvals + yypath->lexeme;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yylpp          = yylpsns + yypath->lexeme;
#endif
    yylexp         = yylexemes + yypath->lexeme;
    yychar         = YYEMPTY;
    yystack.s_mark = yystack.s_base + (yypath->yystack.s_mark - yypath->yystack.s_base);
    memcpy (yystack.s_base, yypath->yystack.s_base, (size_t) (yystack.s_mark - yystack.s_base + 1) * sizeof(YYINT));
    yystack.l_mark = yystack.l_base + (yypath->yystack.l_mark - yypath->yystack.l_base);
    memcpy (yystack.l_base, yypath->yystack.l_base, (size_t) (yystack.l_mark - yystack.l_base + 1) * sizeof(YYSTYPE));
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
    yystack.p_mark = yystack.p_base + (yypath->yystack.p_mark - yypath->yystack.p_base);
    memcpy (yystack.p_base, yypath->yystack.p_base, (size_t) (yystack.p_mark - yystack.p_base + 1) * sizeof(YYLTYPE));
#endif
    yystate        = yypath->state;
    goto yyloop;
#endif /* YYBTYACC */

yyoverflow:
    YYERROR_CALL("yacc stack overflow");
#if YYBTYACC
    goto yyabort_nomem;
yyenomem:
    YYERROR_CALL("memory exhausted");
yyabort_nomem:
#endif /* YYBTYACC */
    yyresult = 2;
    goto yyreturn;

yyabort:
    yyresult = 1;
    goto yyreturn;

yyaccept:
#if YYBTYACC
    if (yyps->save) goto yyvalid;
#endif /* YYBTYACC */
    yyresult = 0;

yyreturn:
#if defined(YYDESTRUCT_CALL)
    if (yychar != YYEOF && yychar != YYEMPTY)
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        YYDESTRUCT_CALL("cleanup: discarding token", yychar, &yylval, &yylloc);
#else
        YYDESTRUCT_CALL("cleanup: discarding token", yychar, &yylval);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */

    {
        YYSTYPE *pv;
#if defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED)
        YYLTYPE *pp;

        for (pv = yystack.l_base, pp = yystack.p_base; pv <= yystack.l_mark; ++pv, ++pp)
             YYDESTRUCT_CALL("cleanup: discarding state",
                             yystos[*(yystack.s_base + (pv - yystack.l_base))], pv, pp);
#else
        for (pv = yystack.l_base; pv <= yystack.l_mark; ++pv)
             YYDESTRUCT_CALL("cleanup: discarding state",
                             yystos[*(yystack.s_base + (pv - yystack.l_base))], pv);
#endif /* defined(YYLTYPE) || defined(YYLTYPE_IS_DECLARED) */
    }
#endif /* defined(YYDESTRUCT_CALL) */

#if YYBTYACC
    if (yyerrctx)
    {
        yyFreeState(yyerrctx);
        yyerrctx = NULL;
    }
    while (yyps)
    {
        YYParseState *save = yyps;
        yyps = save->save;
        save->save = NULL;
        yyFreeState(save);
    }
    while (yypath)
    {
        YYParseState *save = yypath;
        yypath = save->save;
        save->save = NULL;
        yyFreeState(save);
    }
#endif /* YYBTYACC */
    yyfreestack(&yystack);
    return (yyresult);
}
